#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 config.cgi @(#)config.cgi	1.25 SCCS/s.config.cgi  99/07/12 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script config.cgi> Script to generate state modification form

# CODEINFO END ########################################################

# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_eval {
    # Variable aliases and procedure imports
    namespace import webSubmit::database::*
    alias webSubmit WebSubmit javaScriptHead
    alias webSubmit cgiHead userPath wsLibDir
    alias webSubmit::master DB dbKeyList userUptoDate userConfigFile
    set cgiTarget master

    # Build master DB info
    webSubmit::master::createMasterDb

    # CGI import data
    cgi_input
    set varList [safeImport]

    if {$varList != ""} {
	# Process imported data
	foreach var $varList {
	    # Determine key, attribute, and value
	    if [regexp {([^_]+)_(.*)} $var match attr key] {
		set value [set $var]
		setDbVal webSubmit::master $value $key $attr
	    }
	}

	# Serialize into user config tcl file
	serialize ::webSubmit::master DB $userConfigFile
    }

    # Set up an ordered list of scripts/containers
    set sortedKeyList [lsort -command webSubmit::master::compAbs $dbKeyList]

    # CGI configuration
    cgi_root $cgiHead
    set formProcessor config

    # HTTP Header
    cgi_http_head

    # Body
    cgi_html {
	cgi_body link=antiquewhite vlink=rosybrown bgcolor=antiquewhite {

	    # Force reload, extended of linkbar
	    cgi_javascript SRC="$javaScriptHead/forceLinkBar.js" {}

	    cgi_h2 "WebSubmit Configuration"
	    cgi_p "The following contains information about the current user configuration\
                        of WebSubmit.  From this page, modules or classes of modules can be\
                        turned on or off, and users may modify the mode used for each module."
	    cgi_br

	    if {!($userUptoDate)} {
		cgiWarn config.cgi "User configuration out of date with respect to system\
			configuration.  New global configuration has been loaded; you may need\
			to adjust your settings for modes and state."
	    }

	    cgi_form $formProcessor target=$cgiTarget method="GET" {
		cgi_table width=100% border=2 cellpadding=3 {
		    cgi_table_row {
			cgi_th "[cgi_font size=+1 color=blue Title]"
			# cgi_th "[cgi_font size=+1 color=blue Type]"
			cgi_th "[cgi_font size=+1 color=blue State]"
			cgi_th "[cgi_font size=+1 color=blue Mode]"
		    }

		    # NODES first
		    foreach key $sortedKeyList {
			set type [getDbVal "::" $key type]
			set defaultMode [getDbVal "::" $key defaultMode]
			set host [getDbVal "::" $key host]
			if {"$host" == "generic"} {set host ""}
			set title [getDbVal "::" $key title]
			set visible [getDbVal "::" $key visible]
			set state [getDbVal "::" $key state]
			set build [getDbVal "::" $key build]
			if {$type != "CONTAINER" && $visible != "OFF"} {
			    cgi_table_row {
				cgi_td "[cgi_font color=darkmagenta "$host $title"]"
				# cgi_td align=center "$type"
				
				cgi_table_data nowrap align=center {
				    puts "On"
				    cgi_radio_button state_$key=ON checked_if_equal=$state
				    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				    puts "Off"
				    cgi_radio_button state_$key=OFF checked_if_equal=$state
				}
				
				cgi_table_data nowrap align=center {
				    if {$type == "SCRIPT" && $defaultMode != ""} {
					puts "Basic"
					cgi_radio_button defaultMode_$key=BASIC checked_if_equal=$defaultMode
					puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
					puts "Advanced"
					cgi_radio_button defaultMode_$key=ADVANCED checked_if_equal=$defaultMode
				    } else {
					puts "N/A"
				    }
				}
			    }
			}
		    }
		}
		cgi_br
		cgi_submit_button "=Update Configuration"
		cgi_reset_button "Reset"
	    }
	}
    }
}






















