#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 formWrapper.cgi @(#)formWrapper.cgi	1.4 SCCS/s.formWrapper.cgi  99/06/19 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# CODEINFO BEGIN ######################################################

# info script formWrapper.cgi>  Simple Wrapper script to forward WebSubmit 
#    connections to other CGI scripts
#
# Code assumes the following:
#  1. formWrapper.cgi is located in directory $wsRootDir/bin
#  2. The script that is being wrapped is located in $wsWrapDir/scriptName

# CODEINFO END ########################################################


# Load WebSubmit for authentication
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_eval {
    alias webSubmit wsWrapDir wsBinDir
    if {[pwd] == "$wsBinDir"} {
	cgiBomb formWrapper.cgi "This script cannot be executed directly - exiting"
    }

    set moduleName "[file tail [pwd]]"
    set scriptName "$moduleName.cgi"
    set scriptPath [file join $wsWrapDir $scriptName]
    if ![file exists $scriptPath] {
	cgiBomb $scriptName "Parent script ($scriptPath) cannot be located - exiting"
    }

    if [info exists env(REQUEST_METHOD)] {
	set webSubmit::cgi::pipeDone 0
	if {$env(REQUEST_METHOD) == "GET"} {
	    set pipeId [open "|$scriptPath" r]
	} else {
	    # Method = POST
	    # Collect any form data from standard input
	    if [info exists env(CONTENT_LENGTH)] {
		set data [read stdin $env(CONTENT_LENGTH)]

		# Write stdin to a temp file
		set tmpFileName "/tmp/stdin.[pid]"
		set tid [open "$tmpFileName" w]
		foreach line [split $data \n] {
		    puts $tid $line
		    flush $tid
		}
		close $tid
	    }

	    #  Open a pipe to $targetScript
	    set pipeId [open "|/bin/cat $tmpFileName | $scriptPath" r]
	}

	# Set up an event handler for reading from the channel
	fileevent $pipeId readable [list pipeRead $pipeId webSubmit::cgi::pipeDone]
	fconfigure $pipeId -buffering line
	
	# Wait for completion of output from pipe
	vwait webSubmit::cgi::pipeDone

	if [info exists tmpFileName] {
	    file delete $tmpFileName
	}
    } else {
	cgiBomb $scriptName "Invalid environment for script execution"
    }
}























































