#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 genExecCmd.cgi @(#)genExecCmd.cgi	1.3 SCCS/s.genExecCmd.cgi  99/05/20 


# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script genExecCmd.cgi> Display command interface to remote system.

# CODEINFO END ########################################################

# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head
    
    # Variable aliases
    alias webSubmit cgiHead imgHead docHead
    alias webSubmit::auth hostList
    set helpHead "$docHead/help.html#commands"
    set helpGif "$imgHead/button_help.gif"
    cgi_imglink help $helpGif alt=Help
    set cgiTarget output
    set method "GET"

    # Process CGI input
    set moduleVarList [list hostName moduleName mode title]
    set reqVarList [list moduleName title]
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # CGI configuration
    cgi_root $cgiHead
    set formProcessor ${moduleName}submit

    # Commands
    set cmdList [list ls ps grep cp rm ln cat]

    # Command options
    set lsOpt [list "" "-l" "-al" "-F" "-ld"]
    set psOpt [list "-e" "-ef" "-elf" "-el"]
    set grepOpt [list "" "-v" "-n" "-i"]
    set cpOpt [list "" "-i" "-f"]
    set rmOpt [list "" "-i" "-f"]
    set lnOpt [list "" "-s" "-f"]
    set catOpt [list "" "-t" "-e" "-v"]

    # Command descriptions
    set lsDesc "List Files"
    set psDesc "Process status"
    set grepDesc "String search"
    set cpDesc "Copy Files"
    set lnDesc "Link files"
    set rmDesc "Remove files"
    set catDesc "Print file"

    # Fix Options and descriptions
    foreach cmd $cmdList {
	if ![info exists ${cmd}Opt] {
	    set ${cmd}Opt [list ""]
	}

	if ![info exists ${cmd}Desc] {
	    set ${cmd}Desc "Command"
	}
    }

    # Text area
    set numRows 20
    set numCols 70
    for {set i 1} {$i <= $numRows} {incr i} {
	append txt "$i>\n"
    }

    # Formatting
    set txtWidth 25
    set buttonWidth 14
    set tableWidth "90%"
    set manAlign center
    set cmdAlign center
    set txtAlign center
    set descAlign left
    set optAlign center
    
    set workingTitle "$title"

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	
	cgi_body bgcolor=$masterBgcolor {
	    # Form
	    cgi_form $formProcessor target=$cgiTarget method=$method {
		if {"$mode" != ""} {
		    cgi_export mode=$mode
		}
		cgi_export moduleName=$moduleName
		cgi_export title=$title

		# Basic HTML form elements
		cgi_center {
		    cgi_h2 "$workingTitle[cgi_nl]"
		}
		cgi_table width=75%  {
		    cgi_table_row {
			cgi_table_data nowrap {
			    puts "[cgi_font color=blue [cgi_bold "Remote Hostname:"]]"
			    cgi_select hostName {
				foreach host $hostList {
				    cgi_option $host selected_if_equal=ogma.nist.gov
				}
			    }
			}

			cgi_table_data nowrap align=left {
			    puts "[cgi_font color=blue [cgi_bold "Remote Working Directory:"]]"
			    cgi_text "workDir=" size=25 maxsize=40
			}
			cgi_td align=right "[cgi_url [cgi_imglink help] $helpHead target=websubmit_help]"
		    }
		}
		cgi_hr
		cgi_br;cgi_br

		# Basic system commands
		cgi_h4 "[cgi_font color=blue "Simple System Commands"]"
		cgi_p "Single system commands can be executed from this section.  You can\
			either enter a single generic command and submit it, or select from the group\
			of commands provided in the table below.  To use one of the preselected commands,\
			select the desired options and arguments, and then simply click\
			on the command button to execute the command on the remote host."

		cgi_table width=60% {
		    cgi_table_row {
			cgi_td align=right "[cgi_bold Command:]"
			cgi_table_data nowrap align=left {
			    cgi_text "oneCmd=" size=50
			}
			cgi_table_data nowrap align=$cmdAlign {
			    cgi_submit_button "=Submit"
			}
		    }
		}
		cgi_br

		cgi_h5 "[cgi_font color=darkslateblue "Preselected Commands"]"
		cgi_center {
		    cgi_table width=90%  {
			cgi_table_row {
			    cgi_td align=left "[cgi_bold Description]"
			    cgi_td align=center "[cgi_bold Command]"
			    cgi_td align=center "[cgi_bold Options]"
			    cgi_td align=center "[cgi_bold Arguments]"
			    cgi_td align=center "[cgi_bold Manual]"
			}
			
			# Build row for each command
			set space " "
			foreach cmd $cmdList {
			    cgi_table_row {
				cgi_td align=left [set ${cmd}Desc]
				cgi_table_data nowrap align=$cmdAlign {
				    cgi_submit_button "cmd=[padString $cmd $space $buttonWidth]"
				}
				cgi_table_data nowrap align=$optAlign {
				    cgi_select ${cmd}Opts {
					foreach opt [set ${cmd}Opt] {
					cgi_option $opt
					}
				    }
				}
				
				cgi_table_data nowrap align=$txtAlign {
				    cgi_text ${cmd}Args= size=$txtWidth maxsize=40
				}
				
				set manStr "man $cmd"
				cgi_table_data nowrap align=$manAlign {
				    cgi_image_button "man#${cmd}=$helpGif"
				}
			    }
			}
		    }
		}

		cgi_br; cgi_br
		cgi_h4 "[cgi_font color=blue "Sequential Commands"]"
		cgi_p "Commands entered in the following text area will be executed sequentially.\
			Each separate command should be entered on a separate line.  Note that \
			clicking the submit button below [cgi_bold only] submits the commands in \
			the text area, not any listed above."

		cgi_center {
		    cgi_textarea "cmdList=$txt" rows=$numRows cols=$numCols
		    cgi_br
		    cgi_reset_button "Clear Command List"
		    cgi_submit_button "cmd=Submit Command List"
		}
	    }
	}
    }
}



























































































