#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 genExecCmdsubmit.cgi @(#)genExecCmdsubmit.cgi	1.4 SCCS/s.genExecCmdsubmit.cgi  99/06/25 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script genExecCmdsubmit.cgi> Processes input from genExecCmd.cgi and 
#    executes the commands on remote systems

# CODEINFO END ########################################################

# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    # Process CGI input
    set moduleVarList [list hostName moduleName mode title]
    set reqVarList [list hostName moduleName title]
    set varList [cgiImport $moduleVarList $reqVarList]

    # Set up remote information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]

    set singleCmd 1
    set manPage 0
    # Look for special manpage request
    set manIdx [lsearch $varList man#*]
    if {$manIdx != -1} {
	regexp {^man#([^\.]*)\..*} [lindex $varList $manIdx] match cmd
	set cmd "man $cmd"
	set varList [linsert $varList 0 cmd]
	set manPage 1
    }

    if {[info exists oneCmd] && ($oneCmd != "")} {
	if {![info exists cmd] || ([info exists cmd] && ($cmd == ""))} {
	    set cmd [string trim $oneCmd]
	    set varList [linsert $varList 0 cmd]
	}
    }

    # Set working directory
    if {$workDir == ""} {
	# Working directory = Remote HOME
	set workDir $remHome
    } else {
	# Resolve pathname based on remote HOME
	set workDir [mkPathAbs $workDir $remHome]
    }

    # Process command data
    if {$cmd == "Submit Command List"} {
	set singleCmd 0
	# Process list of commands
	regsub -all {(\{|\})} $cmdList "" cmdList
	set tmpList [split $cmdList \n]
	lappend commList "cd $workDir"
	foreach com $tmpList {
	    regsub {^[0-9]+> *} $com "" newcom
	    if {$newcom != ""} {
		lappend commList "echo 'OUTPUT from $newcom:';echo '--------------------';$newcom;echo '';echo ''"
		lappend showCommand $newcom
	    }
	}

	# Pipeline commands
	set command [join $commList ";"]
    } else {
	# Single command
	set cmd [string trim $cmd]
	if [regexp {^man +(.*)} $cmd match manArg] {
	    # Manual page request
	    set manPage 1
	    set command "man -c $manArg | col -b -"
	} else {
	    foreach str [list Opts Args] {
		if [info exists ${cmd}$str] {
		    set $str [set ${cmd}$str]
		} else {
		    set $str ""
		}
	    }
	    set command "cd $workDir; [join [list $cmd $Opts $Args]]"
	    lappend showCommand "[join [list $cmd $Opts $Args]]"
	}
    }

    if [info exists noHTML] {
	# For use with netDirBrowser.java, don't generate HTML page
	if [catch {webSubmit::network::sshCmdExec $remUser $hostName $command} result] {
	    cgi_http_head {
		cgi_content_type "text/plain"
	    }
	    puts "ERROR: $result"
	} else {
	    cgi_http_head {
		cgi_content_type "text/plain"
	    }
	    puts "$result"
	}
    } else {
	# For use with genExecCmd.cgi, do generate HTML page

	set workingTitle "$title Report"

	cgi_html {
	    cgi_head {
		cgi_title "$workingTitle"
	    }
	    
	    cgi_body bgcolor=$masterBgcolor {
		cgi_center {
		    cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
		}

		cgi_h4 "[cgi_font color=darkviolet "Executed on Host:"] $hostName [cgi_nl]\
			[cgi_font color=darkviolet "Executed as user:"] $remUser [cgi_nl]\
			[cgi_font color=darkviolet "Working directory:"] $workDir"
		cgi_hr
		if {!($manPage)} {
		    puts "[cgi_bold "Command(s):"][cgi_nl]"
		    foreach comm $showCommand {
			puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				[cgi_font color=blue [cgi_bold $comm]][cgi_nl]"
		    }
		}
		cgi_hr
		cgi_preformatted {
		    webSubmit::network::sshPipe $remUser $hostName $command
		}
	    }
	}
    }
}























































































































































































































































































































































































































































































































































































































