#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 genFileEdit.cgi @(#)genFileEdit.cgi	1.3 SCCS/s.genFileEdit.cgi  99/05/20 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script genFileEdit.cgi>  Provide editing interaction.

# CODEINFO END ########################################################

# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    # Variable aliases
    alias webSubmit cgiHead imgHead docHead javaScriptHead
    alias webSubmit::auth hostList
    set helpHead "$docHead/help.html#fileEdit"
    set helpGif "$imgHead/button_help.gif"
    cgi_imglink help $helpGif alt=Help

    # Initialization and configuration
    set txtWidth 25
    set remFileName ""
    set remFile ""
    set saveName ""
    set status ""
    set statType "SUCCESS"
    set clobber 1

    # Process CGI input
    set moduleVarList [list hostName moduleName mode title]
    set reqVarList [list moduleName title]
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # CGI configuration
    cgi_root $cgiHead
    set formProcessor $moduleName

    if {[info exists hostName] && ($hostName != "")} {
	# Determine remote information
	set remUser [webSubmit::auth::authTrans $hostName]
	set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]
    }

    if {[info exists loadRem] && ($remFileName != "")} {
	# Load remote file
	if ![catch {webSubmit::network::sshCmdExec $remUser $hostName "/bin/ls -l $remFileName"} stat] {
	    lappend status "File Data: $stat"
	    if [catch {webSubmit::network::getRemFile $remUser $hostName $remFileName} remFile] {
		set statType "ERROR"
		lappend status "Unable to load remote file \"$remFileName\" ($remFile)"
	    } else {
		lappend status "Loaded remote file \"$remFileName\""
		set remFile [join $remFile \n]
	    }
	} else {
	    set statType "ERROR"
	    lappend status "ERROR: $stat"
	}
    } elseif {[info exists saveRem] && ($remFileName != "") && ($remFile != "")} {
	#   set dataList [split $remFile \n]
	set dataList $remFile
	if [catch {webSubmit::network::data2Remote $dataList $remUser $hostName $remFileName $clobber} saveOut] {
	    set statType "ERROR"
	    lappend status "$saveOut"
	} else {
	    lappend status "File saved to \"$remFileName\""
	}
    }

    set workingTitle "$title"

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}

	cgi_body link=antiquewhite bgcolor=$masterBgcolor {

	    # Javascript code for file browser
	    cgi_javascript SRC=$javaScriptHead/browser.js {}
	    cgi_javascript SRC=$javaScriptHead/browse.js {}

	    # Basic HTML form elements
	    cgi_center {
		set formTitle "$workingTitle"
		if {"$hostName" != ""} {
		    set formTitle "$formTitle[cgi_nl]\
                        System [cgi_font color=blue "$hostName"]"
		}
		cgi_h2 $formTitle
	    }

	    # Status of command execution (File load, file save)
	    if {$status != ""} {
		if {[info exists loadRem]} {
		    set operation "File loading operation"
		} elseif {[info exists saveRem]} {
		    set operation "File saving operation"
		} else {
		    set operation "Unknown operation"
		}
		if {"$statType" == "SUCCESS"} {
		    set opStatus succeded
		    set opColor green
		} else {
		    set opStatus failed
		    set opColor red
		}
		cgi_preformatted {
		    set statReport "[cgi_font color=blue\
                        [cgi_bold "$operation"]]\
                        [cgi_font color=$opColor [cgi_bold $opStatus]]."
		    puts $statReport
		    foreach line $status {
			puts "[cgi_nbspace][cgi_nbspace][cgi_font size=-1 [cgi_sample $line]]"
		    }
		}
	    }

	    cgi_form $formProcessor name=fileedit {
		if {"$mode" != ""} {
		    cgi_export mode=$mode
		}
		cgi_export moduleName=$moduleName
		cgi_export title=$title

		cgi_table border=1 align=center {
		    cgi_table_row {
			cgi_table_data nowrap width=150 {
			    puts "[cgi_font color=blue [cgi_bold "Remote Host:"]][cgi_nbspace]"
			    cgi_select hostName {
				foreach host $hostList {
				    if {$host == $hostName} {
					cgi_option $host selected
				    } else {
					cgi_option $host
				    }
				}
			    }
			}

			cgi_table_data nowrap colspan=2 {
			    puts "[cgi_font color=blue [cgi_bold "Remote File:"]][cgi_nbspace]"
			    cgi_text remFileName=$remFileName size=30 maxlength=45
			    puts "<INPUT TYPE=button NAME=fileBrowse VALUE=\"Browse...\"\
				    onClick=\"browse('$cgiHead/netDirBrowse.cgi?form=fileedit&filefield=remFileName&hostName=' +\
				    fileedit.hostName.options\[fileedit.hostName.selectedIndex\].text)\">"
			}
		    }

		    cgi_table_row {
			cgi_table_data nowrap {
			    puts "[cgi_font color=blue [cgi_bold "Action:"]][cgi_nbspace]"
			    cgi_submit_button "loadRem=Load File"
			    puts "[cgi_nbspace][cgi_nbspace]"
			    cgi_submit_button "saveRem=Save"
			    puts "[cgi_nbspace][cgi_nbspace]"
			    cgi_reset_button "Reset"

			}

			cgi_table_data nowrap {
			    puts "[cgi_font color=blue [cgi_bold "Overwrite when saving:"]]\
				    [cgi_nbspace][cgi_nbspace]Yes"
			    if {$clobber} {
				cgi_radio_button clobber=1 checked
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]No[cgi_nbspace]"
				cgi_radio_button clobber=0
			    } else {
				cgi_radio_button clobber=1
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]No[cgi_nbspace]"
				cgi_radio_button clobber=0 checked
			    }
			}
			cgi_td "[cgi_url [cgi_imglink help] $helpHead target=websubmit_help]"
		    }
		    
		    cgi_table_row {
			cgi_table_data nowrap align=center colspan=3 {
			    cgi_textarea remFile=$remFile rows=30 cols=80
			}
		    }
		}
	    }
	}
    }
}









































































































































































































































































































































