#!/itl/links/generic/bin/expect
# WebSubmit 2.0 genFileTrans.cgi @(#)genFileTrans.cgi	1.3 SCCS/s.genFileTrans.cgi  99/05/20 

# Must use expect (expect + tclsh) shell to transfer binary files

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script genFileTrans.cgi> Handle file transfer dialogs

# CODEINFO END ########################################################

# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

 
    # Variable aliases
    alias webSubmit cgiHead imgHead docHead javaScriptHead
    alias webSubmit::auth hostList
    set helpHead "$docHead/help.html#fileTrans"
    set helpGif "$imgHead/button_help.gif"
    cgi_imglink help $helpGif alt=Help

    # Initialization and configuration
    set rarrow "$imgHead/rarrow.gif"
    set larrow "$imgHead/larrow.gif"
    set arrows "$imgHead/arrows.gif"
    set cgiTarget output
    set txtWidth 25

    # Process CGI input
    set moduleVarList [list hostName moduleName mode title]
    set reqVarList [list moduleName title]
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # CGI configuration
    cgi_root $cgiHead
    set formProcessor ${moduleName}submit

    # Set up information about options
    set optList [list clobber]
    set OPT(clobber,text) "Overwrite on Upload"
    set OPT(clobber,argOn) "1"
    set OPT(clobber,argOff) "0"
    set OPT(compress,text) "Compression"
    set OPT(compress,argOn) "-C"
    set OPT(compress,argOff) ""
    set optWidth 3
    set numOpts [llength $optList]
    set rem [expr $numOpts % $optWidth]
    if {$rem == 0} {
	set numRows [expr $numOpts / $optWidth]
    } else {
	set numRows [expr ($numOpts / $optWidth) + 1]
    }

    # Archive format options
    set formatOptList [list zip gziptar compresstar binhex]
    set XFER(zip,text) "Zip"
    set XFER(zip,arg) "zip"
    set XFER(gziptar,text) "Gzipped Tar"
    set XFER(gziptar,arg) "gziptar"
    set XFER(compresstar,text) "Compressed Tar"
    set XFER(compresstar,arg) "compresstar"
    set XFER(binhex,text) "Binhex"
    set XFER(binhex,arg) "binhex"
    set defXfer "zip"

    set workingTitle "$title"

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}

	cgi_body link=antiquewhite bgcolor=$masterBgcolor {
	    # Javascript code for file browser
	    cgi_javascript SRC=$javaScriptHead/browser.js {}
	    cgi_javascript SRC=$javaScriptHead/browse.js {}

	    # Basic HTML form elements
	    cgi_center {
		cgi_h2 "$workingTitle"
	    }
	    cgi_form $formProcessor name=fileTransfer\
                enctype=multipart/form-data target=$cgiTarget {

		if {"$mode" != ""} {
		    cgi_export mode=$mode
		}
		cgi_export moduleName
		cgi_export title

		cgi_table align=center border=1 cellpadding=4 width=90% {
		    cgi_table_row {
			cgi_td "[cgi_url [cgi_imglink help] $helpHead target=websubmit_help]"
			cgi_td align=center "[cgi_font color=midnightblue size=+1 "Browser (Client) System"]"
			cgi_td "[cgi_nbspace]"
			cgi_td align=center "[cgi_font color=midnightblue size=+1 "Remote System"]"
		    }

		    cgi_table_row  {
			cgi_td align=center "[cgi_font color=blue [cgi_bold Host]]"
			cgi_td align=center "[cgi_bold "$env(REMOTE_HOST)"]"
			cgi_td align=center "[cgi_font color=darkmagenta [cgi_bold "Click to Transfer"]]"
			cgi_table_data nowrap align=center {
			    cgi_select hostName {
				foreach host $hostList {
				    cgi_option $host
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_font color=blue [cgi_bold File]]"
			cgi_table_data nowrap valign=top align=left {
			    cgi_br
			    cgi_file_button clientFile size=$txtWidth maxlength=45
			}

			cgi_table_data nowrap {
			    cgi_image_button "Transfer=$arrows"
			}

			cgi_table_data nowrap valign=middle align=left {
			    cgi_text remFile= size=30 maxlength=45
			    puts "<INPUT TYPE=button NAME=fileBrowse VALUE=\"Browse...\"\
				    onClick=\"browse('$cgiHead/netDirBrowse.cgi?form=fileTransfer&filefield=remFile&hostName=' +\
				    fileTransfer.hostName.options\[fileTransfer.hostName.selectedIndex\].text)\">"
			}
		    }
		    
		    cgi_export optList=$optList
		    cgi_table_row {
			cgi_td align=center "[cgi_font color=blue [cgi_bold "Options"]]"
			cgi_table_data nowrap colspan=3 {
			    cgi_table width=100% {
				for {set i 1} {$i <= $numRows} {incr i} {
				    cgi_table_row {
					cgi_table_data nowrap align=left {
					    for {set j [expr $optWidth * ($i - 1)]} {$j < [expr $optWidth * $i]} {incr j} {
						if {[set opt [lindex $optList $j]] != ""} {
						    puts "[cgi_nbspace][cgi_nbspace]\
							    [cgi_font color=darkmagenta "$OPT($opt,text):"] Yes"
						    cgi_radio_button $opt=$OPT($opt,argOn)
						    puts "[cgi_nbspace]No"
						    cgi_radio_button $opt=$OPT($opt,argOff) checked
						    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
						}
					    }
					}
				    }
				}
			    }

			}
		    }

		    # 		    cgi_table_row {
		    # 			cgi_td align=center "[cgi_font color=blue [cgi_bold "Archive<BR>Options"]]"
		    # 			cgi_table_data nowrap colspan=3 {
		    # 			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
			# 				    [cgi_font color=darkmagenta "Remote-to-Client:"]"
		    # 			    cgi_checkbox arcXfer=1
		    # 			    puts [cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]
		    # 			    puts "[cgi_font color=darkmagenta "Unpack Client-to-Remote:"]"
		    # 			    cgi_checkbox unpack=1
		    # 			    puts [cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]
		    # 			    puts "[cgi_font color=darkmagenta "Remove after Unpacking:"]"
		    # 			    cgi_checkbox remArc=1
		    # 			    puts [cgi_nl]
		    # 			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
			# 				    [cgi_font color=darkmagenta "Format:"][cgi_nbspace][cgi_nbspace]"
		    # 			    foreach format $formatOptList {
		    # 				puts "$XFER($format,text)"
		    # 				if {$format == $defXfer} {
		    # 				    cgi_radio_button arcFormat=$XFER($format,arg) checked
		    # 				} else {
		    # 				    cgi_radio_button arcFormat=$XFER($format,arg)
		    # 				}
		    # 				puts [cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]
		    # 			    }
		    # 			    cgi_br
		    
		    # 			}
		    # 		    }
		}
		cgi_p "[cgi_font color=blue [cgi_bold NOTES:]]"
		cgi_bullet_list {
		    cgi_li "At present, only transfers of single files are\
			supported.  Transfers of directories or multiple files\
			do not work."
		    cgi_li "Any directory or filename specified in the blank\
                        for the browser system in downloads will be ignored."
		}
	    }
	}
    }
}









