#!/itl/links/generic/bin/tclsh8.0

# Websubmit configuration
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

# Basic link information
cgi_link overview "Overview:" "#overview"
cgi_link home "WebSubmit Home:" "#master"
cgi_link usage "Usage:" "#usage"

# Build Web Page containing configuration info
cgi_eval {
    # HTTP Header
    cgi_http_head

    # Body
    cgi_html {
	cgi_body link=blue bgcolor=antiquewhite {
	    cgi_h2 "WebSubmit Help Desk"
	    cgi_hr
	    cgi_br

	    cgi_h3 "[cgi_font color=blue "Table of Contents"]"
	    cgi_bullet_list {
		cgi_li "[cgi_bold [cgi_link overview]] The WebSubmit Paradigm"
		cgi_li "[cgi_bold [cgi_link home]] Master Page"
		cgi_bullet_list {
		    cgi_li "Page Layout"
		    cgi_li "Menu Bar"
		    cgi_li "Comments and Reports"
		}
		cgi_li "[cgi_bold [cgi_link usage]]: How to Use WebSubmit"
	    }
	    cgi_br

	    cgi_anchor_name overview
	    cgi_h3 "[cgi_font color=blue "[cgi_bold Overview:]"] The WebSubmit Paradigm"
	    cgi_p "[cgi_bold WebSubmit] is intended to serve as a universal\
		    user interface to networked high-performance computing\
		    resources.  Its primary function is to allow users to\
		    submit job requests, compile codes, execute simple commands,\
		    and control job execution.  A WebSubmit [cgi_italic server]\
		    is used as an intermediary between the client's browser and\
		    one of a group of valid [cgi_italic "compute engines"].\
		    The main WebSubmit page contains links to a group of\
		    [cgi_italic "application modules"], each of\
		    which performs a specific function aimed at a specific compute\
		    engine.  For example, a link on the WebSubmit home page might\
		    point to a module to interface to the IBM SP2 queing system.\
		    Each application module is currently implemented as a simple HTML\
		    form, although future versions of WebSubmit might provide more\
		    flexibility."

	    cgi_p "The main WebSubmit interface to all application modules is completely\
		    user-configurable.  A user may select which modules should be\
		    active at start-up, thus creating a customized environment.\
		    Individual application modules will have several [cgi_italic modes],\
		    each of which is designed for a different level of user proficiency.\
		    The user may configure the mode for each module, as well as its\
		    basic appearance (i.e., what widgets appear in the application module\
		    form)."

	    cgi_br
	    cgi_br
	    cgi_anchor_name master
	    cgi_h3 "[cgi_font color=blue "Master Page"]"
	    cgi_h4 "Page Layout"
	    cgi_p "The master page is laid out into three regions (HTML frames).  Along\
		    the left border of the screen, there is a collection of HTML links\
		    that act as a menu bar.  Each element of the menu either connects\
		    to related information or to configuration features of WebSubmit.\
		    Along the foot of the page there is a link that allows user to contact\
		    the WebSubmit adminstrator regarding problems with the system.  The\
		    central frame contains links to the WebSubmit application modules.\
		    These are organized into classes, each of which contains modules\
		    relevant to a single target compute engine).  Within each class, the individual\
		    application modules are further organized into functionally-related\
		    elements.  For example, if a series of modules is used to interact\
		    with a queing system on a specific machine, then each will appear\
		    under a heading related to the queing system."

	    cgi_h4 "Menu Bar"
	    cgi_bullet_list {
		cgi_li "[cgi_font color=blue Help] [cgi_nl] Link to this WebSubmit help page."

		cgi_br
		cgi_br
		cgi_li "[cgi_font color=blue Messages][cgi_nl]\
		        Read the current group of messages related to WebSubmit.  These\
			messages will typically contain information about events on the\
			system related to WebSubmit, or matters that the system administrator\
			considers relevant."

		cgi_br
		cgi_br
		cgi_li "[cgi_font color=blue Links][cgi_nl]\
		        The links Web page contains a set of links that point to information\
			resources connected to WebSubmit functionality and application\
			modules."
		cgi_br
		cgi_br
		cgi_li "[cgi_font color=blue Configure][cgi_nl]\
		        The configuration page is used to change the visual appearance of the\
			WebSubmit master page.  It allows users to delete or reinstall\
			individual application modules from their execution environment."
		
		cgi_br
		cgi_br
		cgi_li "[cgi_font color=blue Home][cgi_nl]\
		        This link will return users to the master WebSubmit page containing\
			links to all available application modules"
	    }

	    cgi_h4 "[cgi_bold "Comments and Reports"]"
	    cgi_p "At the foot of the master page (and all WebSubmit pages), there is a link\
		    that allows users to send mail to the WebSubmit administrator.  Mail\
		    should be sent to the WebSubmit administrator to report problems with the\
		    software, to request changing the user's status (active or inactive),\
		    or to present general inquiries."


	    cgi_br
	    cgi_br
	    cgi_anchor_name usage
	    cgi_h3 "[cgi_font color=blue "Usage: How to Use WebSubmit"]"
	    cgi_p "WebSubmit was designed to be easy to use.  In fact, it should be very\
		    similar to the types of interfaces encountered in other places on the\
		    Web.  The basic usage process for a simple request would be as follows:"

	    cgi_number_list {
		cgi_li "Go to WebSubmit master (home) page"
		cgi_li "Click the link to the desired application module"
		cgi_li "Fill out the form for the application module"
		cgi_li "Submit the form by clicking the submit button"
	    }

	    cgi_p "Directions for specific application modules are contained below.  The\
		    behavior of the forms elements within each module should be quite\
		    similar, so familiarity with one form should allow easy use of others."
		

	}
    }
}


