#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 linkbar.cgi @(#)linkbar.cgi	1.16 SCCS/s.linkbar.cgi  99/06/25 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script linkbar> Script to generate link bar on left side of page 

# CODEINFO END ########################################################

# webSubmit setup
set wsLibDir "/sasp/WebSubmit/webSubmit2.5/lib"
lappend auto_path $wsLibDir
package require webSubmit

# Check to see if this is being accessed with a certificate
set verified 0
set certExists [webSubmit::auth::hasCert]

if {$certExists} {
    set dump 0
    # Source websubmit.conf for authentication
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf
    if {$::webSubmit::userName != ""} {
	set verified 1
    }
}

cgi_eval {
    # Alias definitions
    alias webSubmit cgiHead docHead certManager javaScriptHead
    alias webSubmit::master DB nodeScriptList dbKeyList
    alias webSubmit::auth certEnvName dump
    catch {namespace import webSubmit::database::*}

    # Build master DB info
    webSubmit::master::createMasterDb

    # HTTP Header
    cgi_http_head

    # Define image links
    cgi_imglink logo "$docHead/logoFatBack.jpg" vspace=0 hspace=0 border=0

    # Links for image-swapped stuff
    cgi_link home\
        "[cgi_img "$docHead/homeOff.gif" NAME=home BORDER=0]"\
        "$cgiHead/master.cgi"\
	"onMouseOver=imageOn('home'); return setMsg('WebSubmit Home Page')"\
	"onMouseOut=imageOff('home'); return setMsg('')"\
        "onClick=location.reload(true)"\
        target=master
    cgi_link info\
        "[cgi_img "$docHead/infoOff.gif" NAME=info BORDER=0]"\
        "$cgiHead/links.cgi"\
	"onMouseOver=imageOn('info'); return setMsg('Links to related resources')"\
	"onMouseOut=imageOff('info'); return setMsg('')"\
        target=master
    cgi_link faq\
        "[cgi_img "$docHead/faqOff.gif" NAME=faq BORDER=0]"\
        "$docHead/FAQ.html" \
	"onMouseOver=imageOn('faq'); return setMsg('WebSubmit FAQ')"\
	"onMouseOut=imageOff('faq'); return setMsg('')"\
        target=websubmit_help
    cgi_link messages\
        "[cgi_img "$docHead/messagesOff.gif" NAME=messages BORDER=0]"\
        "$cgiHead/motd.cgi" \
	"onMouseOver=imageOn('messages'); return setMsg('WebSubmit-related Messages')"\
	"onMouseOut=imageOff('messages'); return setMsg('')"\
        target=master
    cgi_link settings\
        "[cgi_img "$docHead/settingsOff.gif" NAME=settings BORDER=0]"\
        "$cgiHead/config.cgi" \
	"onMouseOver=imageOn('settings'); return setMsg('WebSubmit Settings (Modes, State)')"\
	"onMouseOut=imageOff('settings'); return setMsg('')"\
        target=master
    cgi_link help\
        "[cgi_img "$docHead/helpOff.gif" NAME=help BORDER=0]"\
        "$docHead/help.html"\
	"onMouseOver=imageOn('help'); return setMsg('WebSubmit Help Documentation')"\
	"onMouseOut=imageOff('help'); return setMsg('')"\
        target=websubmit_help
    cgi_imglink modules\
        "$docHead/modules.gif" border=0

    # Define page links
    if {$certExists && $verified} {
	foreach key $nodeScriptList {
	    set host [getDbVal webSubmit::master $key host]
	    set sTitle [getDbVal webSubmit::master $key sTitle]
	    if {"$host" == "generic"} {
		set shortTitle "$sTitle"
	    } else {
		set hostProper [lindex [split $host "."] 0]
		set shortTitle "$hostProper $sTitle"
	    }
	    set link [getDbVal webSubmit::master $key url]
	    cgi_link $key $shortTitle $link target=master
	}
	set linkList [list home help faq messages info settings]
	set modLinkList [lsort -command webSubmit::master::compAbs $nodeScriptList]
    } else {
	set linkList [list help faq]
    }


    # Body
    cgi_html {
	cgi_head {
	    cgi_title "WebSubmit Link Bar Frame"
	}

	cgi_body vlink=antiquewhite bgcolor=\#1c0b5A link=antiquewhite text=red {
	# Load image swapping code
	cgi_javascript SRC="$javaScriptHead/imgSwap.js" {}
	
	# Image array for swapping images
	cgi_javascript {
	    puts "if (document.images) {"
	    puts "  var onImgArray = new Array()"
	    puts "  var offImgArray = new Array()"
	    foreach link $linkList {
		puts "  onImgArray\[\"$link\"\] = new Image(150,25)"
		puts "  offImgArray\[\"$link\"\] = new Image(150,25)"
		puts "  onImgArray\[\"$link\"\].src = \"$docHead/${link}On.gif\""
		puts "  offImgArray\[\"$link\"\].src = \"$docHead/${link}Off.gif\""
	    }
	    puts "}"
	}

	cgi_center {
	    puts "[cgi_imglink logo]"
	}

	foreach link $linkList {
	    puts "[cgi_link $link][cgi_nl]"
	}

	if {$verified} {
	    # Module links
	    set linkStr ""
	    foreach key $modLinkList {
		set state [getDbVal webSubmit::master $key state]
		if {$state == "ON"} {
		    append linkStr "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font size=-1 [cgi_link $key]][cgi_nl]"
		}
	    }
	    puts "[cgi_imglink modules][cgi_nl]"
	    puts "$linkStr"
	}
    }
}
}



































































































































































































































































































































































































































































































