#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 llGaussian.cgi @(#)llGaussian.cgi	1.3 SCCS/s.llGaussian.cgi  99/07/08 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script llGaussian.cgi> LL Gaussian job form generator.

# CODEINFO END ########################################################

# Load WebSubmit package
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    catch {namespace import webSubmit::loadleveler::*}
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::forms::session::*}
    catch {namespace import webSubmit::formElements::*}

    # CGI configuration
    alias webSubmit cgiHead imgHead
    cgi_root $cgiHead
    cgi_link gaussian "Gaussian Home Page" "http://www.gaussian.com"
    cgi_link config "configuration module" "$cgiHead/config.cgi"
    cgi_imglink gaussLogo "$imgHead/gauss.gif" alt="Gaussian Logo"

    alias webSubmit GaussianVersions
    alias webSubmit::loadleveler CLASS classNameList Gaussian 

    # Process CGI Input
    set moduleVarList [list remDir remGaussianFile locGaussianFile\
        clobberGaussian Gaussian(OutputType) Gaussian(Nproc)\
        Gaussian(JobNameTxt) Gaussian(Output) Gaussian(NProcType)\
        loadedSessName class job_name notify_user gvers.option\
        hostName moduleName bqs node title]
    set reqVarList [list hostName moduleName bqs mode title]
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # Load the current session
    if {[info exists loadedSessName] && "$loadedSessName" != ""} {
	session load -name $loadedSessName $moduleName $hostName
    } else {
	session load $moduleName $hostName
    }	
    getSessionData

    # Read LoadLeveler Keyword Database
    createKeywordDb

    # Get LoadLeveler Class Information
    getClassInfo $hostName
    eval alias webSubmit::loadleveler $webSubmit::loadleveler::dbKeyList

    # CGI configuration
    set formProcessor ${moduleName}submit

    # Get Remote Site information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]

    # Get user notification email address from auth.db
    webSubmit::auth::createAuthDb
    set notify_user [webSubmit::database::getDbVal webSubmit::auth $webSubmit::auth::wsID email]

    if {${gvers.option} == ""} {
	set gvers.option 0
    }

    if {$initialdir == ""} {
	set initialdir $remHome
    }

    if {$clobberGaussian == ""} {
	set clobberGaussian 0
    }

    if {$class == ""} {
	set class [lindex $classNameList 0]
    }

    # Set up help information
    set HELP(elementList) [list initialdir remGaussianFile locGaussianFile clobberGaussian Gaussian(OutputType)\
	    Gaussian(JobNameTxt) Gaussian(NProcType) notify_user class job_name gvers.option]
    set HELP(initialdir,header) "Working Directory"
    set HELP(initialdir,text) "Directory from which the job control script is submitted.  If a relative pathname is provided, it is\
	    interpreted relative to <FONT color=yellow><SAMP>$remHome</SAMP></FONT>.  If no directory is specified, your\
	    home directory is assumed."
    set HELP(remGaussianFile,header) "Gaussian Input File"
    set HELP(remGaussianFile,text) "This filename specifies a Gaussian input file on <FONT color=yellow><SAMP>\
	    $hostName</SAMP></FONT>.  If a relative pathname is given for this file, it is interpreted\
	    as relative to the specified working directory.  The file must exist before job submission."
    set HELP(locGaussianFile,header) "Local Gaussian Input File"
    set HELP(locGaussianFile,text) "Gaussian input file on the client (browser) machine.  The file must exist,\
	    and will be uploaded to the remote host on form submission."
    set HELP(clobberGaussian,header) "Overwrite"
    set HELP(clobberGaussian,text) "If a local Gaussian input file is specified, and a file by the same name\
	    exists on the remote host, this flag determines whether the latter is overwritten during upload."
    set HELP(Gaussian(OutputType),header) "Output Filenames based on:"
    set HELP(Gaussian(OutputType),text) "Simplified mechanism for determining Gaussian file names.  The options\
	    are as follows: <FONT color=yellow><SAMP>Gaussian Input File Name</SAMP></FONT> - Output filename is set\
	    based on the name of the input file; <FONT color=yellow><SAMP>User-defined</SAMP></FONT> - The output\
	    file is set to the specified name."
    set HELP(Gaussian(NProcType),header) "Number of Processors"
    set HELP(Gaussian(NProcType),text) "The number of processors to use in your Gaussian job.  The options are as\
	    follows: <FONT color=yellow><SAMP>From Gaussian Input File</SAMP></FONT> - An <FONT color=yellow>\
	    <SAMP>%Nproc</SAMP></FONT> directive contained in the Gaussian input file is used for the number\
	    of processors; <FONT color=yellow><SAMP>User-defined</SAMP></FONT> - The number of processors\
	    specified is utilized."
    set HELP(notify_user,header) "Notification E-mail Address"
    set HELP(notify_user,text) "Send email to this address upon completion of the job."
    set HELP(job_name,header) "Job Script File Name:"
    set HELP(job_name,text) "This is the name that will be used for the file containing your LoadLeveler job script.\
	    This script file contains LL directives specifying job parameters, and the actual executable\
	    script that constitutes your job.  The options are as follows: <FONT color=yellow><SAMP>\
	    Gaussian Input File Name</SAMP></FONT> - name is based on Gaussian input file name;\
	    <FONT color=yellow><SAMP>User-defined</SAMP></FONT> - name is based on that specified."
    set HELP(gvers.option,header) "Gaussian Version"
    set HELP(gvers.option,text) "This is the version of Gaussian to run.  The available versions are:  $GaussianVersions."
    set HELP(class,header) "Job Class"
    set HELP(class,text) "The job class determines the resource limits (maximum CPU time, number of processors) and\
	    priority for your job.  You should select the class that best meets the requirements for your job."

    # Set up help information
    helpSetup HELP

    set workingTitle "$bqs $title"
    
    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	cgi_body bgcolor=$masterBgcolor {
	    # Form
	    cgi_form sessionManager enctype=multipart/form-data {
		# Basic HTML form elements
		cgi_center {
		    cgi_table cellpadding=3  {
			cgi_table_row {
			    cgi_td align=center bgcolor=darkslateblue "[cgi_imglink gaussLogo]"
			    
			    cgi_table_data nowrap align=center bgcolor=darkslateblue {
				cgi_h2 "[cgi_font color=white\
                                   "$workingTitle[cgi_nl]\
		                    System [cgi_font color=$masterBgcolor "$hostName"]"]"
			    }
			    
			    cgi_td align=center bgcolor=darkslateblue "[cgi_imglink gaussLogo]"
			}
		    }
		}

		# Instructions
		cgi_h3 "[cgi_font color=darkmagenta Instructions:]"
		cgi_number_list {
		    cgi_li "Fill out the required elements.  The working directory is the directory on the\
			    remote computing system in which Gaussian commands are executed.  The Gaussian Input file can\
			    either exist on this system, or it can be uploaded from the system on which\
			    your browser is running.  Indicate [cgi_bold one] Input file to be used."
		    cgi_li "Fill+ out the optional elements as necessary.  Default values are provided if\
			    these elements are not changed."
		}
		cgi_p "For additional information on Gaussian, refer to the [cgi_link gaussian].  This form has two modes:\
			[cgi_bold BASIC] mode provides a minimum number of input elements, whereas [cgi_bold ADVANCED] mode\
			allows more flexibility.  Modes can be switched using the [cgi_link config]."
		cgi_br

		cgi_table cellpadding=5 border=1  {
		    ###########################
		    # File Location Information
		    ###########################
		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Required Information"]"][cgi_nbspace][cgi_nbspace]\
				[cgi_font color=white "(Current Form Mode: "][cgi_font color=yellow\
				$mode][cgi_font color=white )]"
		    }
		    
		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link gvers.option]] on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    feGaussianVersions gvers $GaussianVersions\
                                ${gvers.option}
			}
		    }
		    
		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link initialdir]] on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    cgi_text initialdir=$initialdir size=35 maxlength=45
			}
		    }
		    
		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link remGaussianFile]] on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    cgi_text remGaussianFile=$remGaussianFile size=35 maxlength=45
			}
		    }
		    
		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link locGaussianFile]][cgi_nl] to upload from\
				[cgi_font color=darkmagenta "[cgi_sample $env(REMOTE_HOST)]"]"
			cgi_table_data nowrap {
			    cgi_file_button locGaussianFile size=35
			    cgi_br
			    puts "[cgi_link clobberGaussian] on [cgi_font color=darkmagenta "[cgi_sample $hostName]"]:[cgi_nbspace][cgi_nbspace]"
			    cgi_radio_button clobberGaussian=1 checked_if_equal=$clobberGaussian
			    puts "Yes[cgi_nbspace][cgi_nbspace]"
			    cgi_radio_button clobberGaussian=0 checked_if_equal=$clobberGaussian
			    puts "No"
			}
		    }


		    #####################
		    # Optional Elements
		    #####################
		    if {$mode == "ADVANCED"} {
			cgi_table_row {
			    cgi_td colspan=2 bgcolor=darkslateblue "[cgi_font size=+1 color=white [cgi_bold "Optional Information"]]"
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link notify_user]]"
			    cgi_table_data nowrap {
				cgi_text notify_user=$notify_user size=35
			    }
			}

			#########################
			# File Naming Conventions
			#########################
			cgi_table_row {
			    cgi_td colspan=2 "[cgi_font color=darkmagenta [cgi_bold "File Naming Conventions"]]"
			}	
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link Gaussian(OutputType)]]"
			    cgi_table_data nowrap {
				cgi_select Gaussian(OutputType) {
				    cgi_option "Gaussian Input File Name" value=IF selected_if_equal=$Gaussian(OutputType)
				    cgi_option "Job Number" value=JN selected_if_equal=$Gaussian(OutputType)
				    cgi_option "User-defined, Enter Name:" value=UD selected_if_equal=$Gaussian(OutputType)
				}
				cgi_text Gaussian(Output)=$Gaussian(Output) size=25
			    }
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link job_name]]"
			    cgi_table_data nowrap {
				cgi_select job_name {
				    cgi_option "Gaussian Input File Name" value=IF selected_if_equal=$job_name
				    cgi_option "User-defined, Enter Name:" selected_if_equal=$job_name
				}
				cgi_text Gaussian(JobNameTxt)=$Gaussian(JobNameTxt) size=25
			    }
			}


			##############################
			# LoadLeveler Job Information
			##############################
			cgi_table_row {
			    cgi_td colspan=2 "[cgi_font color=darkmagenta [cgi_bold "LoadLeveler Job Specifications"]]"
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link class]]"
			    cgi_table_data nowrap {
				cgi_table width=100% {
				    cgi_table_row {
					cgi_td align=center "[cgi_font size=-1 [cgi_bold "Class"]]"
					cgi_td align=center "[cgi_font size=-1 [cgi_bold "Max Processors"]]"
					cgi_td align=center "[cgi_font size=-1 [cgi_bold "Priority"]]"
					cgi_td align=center "[cgi_font size=-1 [cgi_bold "Wall-Clock Limit (hh:mm:ss)"]]"
					cgi_td align=center "[cgi_font size=-1 color=darkmagenta [cgi_bold "SELECT"]]"
				    }
				    
				    foreach name $classNameList {
					cgi_table_row {
					    cgi_td align=center "[cgi_font size=-1 $name]"
					    cgi_td align=center "[cgi_font size=-1 $CLASS($name,max_processors)]"
					    cgi_td align=center "[cgi_font size=-1 $CLASS($name,priority)]"
					    regexp {([^,]+).*} $CLASS($name,wall_clock_limit) match limit
					    cgi_td align=center "[cgi_font size=-1 $limit]"
					    cgi_table_data nowrap align=center {
						cgi_radio_button class=$name checked_if_equal=$class
					    }
					}
				    }
				}
			    }
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link Gaussian(NProcType)]]"
			    cgi_table_data nowrap {
				cgi_select Gaussian(NProcType) {
				    cgi_option "From Gaussian Input File" value=IF selected_if_equal=$Gaussian(NProcType)
				    cgi_option "User-defined, Enter Value:" value=UD selected_if_equal=$Gaussian(NProcType)
				}
				cgi_text Gaussian(Nproc)=$Gaussian(Nproc) size=3
			    }
			}
		    } else {
			# Set default values for variables if form is in basic mode
			set Gaussian(OutputType) "IF"
			set Gaussian(NProcType) "IF"
			set class [lindex $classNameList 0]
			set job_name "IF"
			cgi_export Gaussian(OutputType)=$Gaussian(OutputType)
			cgi_export Gaussian(NProcType)=$Gaussian(NProcType)
			cgi_export class=$class
			cgi_export job_name=$job_name
			cgi_export notify_user=$notify_user
		    }

		    #####################
		    # Job Submission
		    #####################
		    cgi_table_row {
			cgi_td colspan=2 bgcolor=darkslateblue "[cgi_font size=+1 color=white [cgi_bold "Submit Gaussian Job"]]"
		    }

		    cgi_table_row {
			cgi_table_data nowrap colspan=2 {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_submit_button "action=Submit Job"
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_reset_button
			}
		    }

		    cgi_table_row {
			cgi_table_data nowrap colspan=2 {
			    cgi_export mode=$mode
			    cgi_export moduleName=$moduleName
			    cgi_export hostName=$hostName
			    cgi_export title=$title
			    cgi_export bqs=$bqs
			    cgi_export formProcessor=$cgiHead/$formProcessor.cgi
			    # Session Manager
			    sessionManager $moduleName $hostName
			}
		    }
		}
	    }
	}
    }
}




































































































