#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 llJob.cgi @(#)llJob.cgi	1.5 SCCS/s.llJob.cgi  99/07/23 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script llJob.cgi> LL job form generator.

# CODEINFO END ########################################################

# Load WebSubmit package
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head
    
    catch {namespace import webSubmit::loadleveler::*}
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::forms::session::*}
    catch {namespace import webSubmit::database::*}
    catch {namespace import webSubmit::formElements::*}
        
    # CGI configuration
    alias webSubmit cgiHead
    cgi_root $cgiHead
    cgi_link config "configuration module" "$cgiHead/config.cgi"

    alias webSubmit::loadleveler CLASS classNameList

    # Process CGI input
    set moduleVarList [list initialdir input output error class\
	min_processors max_processors job_name executable arguments\
        job_type useReqs LLREQ(Memory) LLREQ(Adapter) LLREQ(Feature)\
	env_Copy env_CopyString env_ExcludeString env_CopyValueString\
        usePrefs LLPREF(Memory) LLPREF(Adapter) LLPREF(Feature) jobScript\
        shell startdate hold parallel_path loadedSessName\
        hostName moduleName bqs mode title]
    set reqVarList [list hostName moduleName bqs mode title]
#   initVars $moduleVarList
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # Load the current session
    if {[info exists loadedSessName] && "$loadedSessName" != ""} {
	session load -name $loadedSessName $moduleName $hostName
    } else {
	session load $moduleName $hostName
    }	
    getSessionData

    # Read LoadLeveler Keyword Database
    createKeywordDb

    # Get LoadLeveler Class Information
    getClassInfo $hostName
    eval alias webSubmit::loadleveler $webSubmit::loadleveler::dbKeyList

    # CGI configuration
    set formProcessor ${moduleName}submit

    # Get Remote Site information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]

    # Initialization of variables
    if {$initialdir == ""} {
	set initialdir $remHome
    }

    if {$class == ""} {
	set class [lindex $classNameList 0]
    }

    if {$min_processors == ""} {
	set min_processors 1
    }

    if {$output == ""} {
	set output {$(jobid).out}
    }

    if {$error == ""} {
	set error {$(jobid).err}
    }

    if {$input == ""} {
	set input /dev/null
    }

    #######################
    # Generate HTML via CGI
    #######################
    # HTTP Header
    cgi_http_head
    
    # Set up help information
    set HELP(elementList) [list initialdir input output error class processors\
	    job_name executable arguments job_type requirements LLREQ(Memory) LLREQ(Adapter) LLREQ(Feature)\
	    environment preferences LLPREF(Memory) LLPREF(Adapter) LLPREF(Feature) jobScript\
	    shell startdate hold parallel_path]
    set HELP(initialdir,header) "Working Directory"
    set HELP(initialdir,text) "Directory to be used as the working directory.  If a relative pathname is provided,\
	    it is interpreted relative to <FONT color=yellow><SAMP>$remHome</SAMP></FONT>.  If no directory\
	    is specified, your home directory is assumed."
    set HELP(input,header) "Standard Input File:"
    set HELP(input,text) "Standard input will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(output,header) "Standard Output File:"
    set HELP(output,text) "Standard output will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(error,header) "Standard Error File:"
    set HELP(error,text) "Standard error will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(job_type,header) "Job Type"
    set HELP(job_type,text) "This determines what type of job will be submitted.  The options are as follows:\
	    <FONT color=yellow><SAMP>serial</SAMP></FONT> - Serial job utilizing one processor;<FONT color=yellow>\
	    <SAMP>parallel</SAMP></FONT> - General parallel job using multiple processors;<FONT color=yellow><SAMP>\
	    pvm3</SAMP></FONT> - Parallel Virtual Machine (pvm) job."
    set HELP(class,header) "Job Class"
    set HELP(class,text) "The job class determines the resource limits (maximum CPU time, number of processors) and\
	    priority for your job.  You should select the class that best meets the requirements for your job."
    set HELP(processors,header) "Number of Processors"
    set HELP(processors,text) "Specify the minimum and maximum number of processors needed for your parallel job.\
	    The default number of min_processors is 1; the default value for max_processors is min_processors."
    set HELP(job_name,header) "Job Name"
    set HELP(job_name,text) "This name is simply used as an identifier for your job.  This may make it easier\
	    to identify the job when examining queue status.  Output and error files can also be named using\
	    the job name by specifying the \$(job_name) command macro."
    set HELP(executable,header) "Executable Code"
    set HELP(executable,text) "Executable code to be run in your job; if specified as a relative path, it will be\
	    interpreted as relative to your working directory.  <FONT color=yellow>Arguments</FONT> are the\
	    arguments to this executable code.  If the code is not in your working directory,\
	    then you must either use an absolute pathname or include your path in the environment.  If an\
	    <FONT color=yellow>Executable Script</FONT> is specified, the <FONT color=yellow>Executable Name</FONT>\
	    is ignored and the script is executed instead."
    set HELP(requirements,header) "Requirements"
    set HELP(requirements,text) "Requirements specify resources that must be present when your job executes.  In order\
	    to include requirements, check the box given."
    set HELP(LLREQ(Memory),header) "Memory (Mb):"
    set HELP(LLREQ(Memory),text) "Amount of memory required for your job (specified in Megabytes)."
    set HELP(LLREQ(Adapter),header) "Adapter:"
    set HELP(LLREQ(Adapter),text) "Type of adapter to use for your parallel job."
    set HELP(LLREQ(Feature),header) "Feature:"
    set HELP(LLREQ(Feature),text) "Additional feature requirements for your jobs"
    set HELP(preferences,header) "Preferences"
    set HELP(preferences,text) "Preferences specify resources that you would like to be present when your job executes.\
	    LoadLeveler will attempt to satisfy these preferences, and if they can't be met, it will attempt to\
	    satisfy requirements.  In order to include preferences, check the box given."
    set HELP(LLPREF(Memory),header) "Memory (Mb):"
    set HELP(LLPREF(Memory),text) "Amount of memory desired for your job (specified in Megabytes)."
    set HELP(LLPREF(Adapter),header) "Adapter:"
    set HELP(LLPREF(Adapter),text) "Type of adapter desired for your parallel job."
    set HELP(LLPREF(Feature),header) "Feature:"
    set HELP(LLPREF(Feature),text) "Additional feature preferences for your jobs"
    set HELP(environment,header) "Job Environment"
    set HELP(environment,text) "Certain properties of the execution environment can be set within LoadLeveler.\
	    By checking the button to copy all environment variables, all variables from your\
	    execution environment will be copied and used by LoadLeveler.  It is also possible to specify\
	    individual variables to include or exclude, and values can be set.  <FONT color=yellow><SAMP>\
	    Including Variables:</SAMP></FONT> Specify the list of variables to include, separated by commas.\
	    <FONT color=yellow><SAMP>Excluding Variables:</SAMP></FONT> Specify the list of variables to exclude,\
	    separated by commas.<FONT color=yellow><SAMP>Specifying by value:</SAMP></FONT> Provide a list of the\
	    form <FONT color=yellow><SAMP>var=value</SAMP></FONT> to be included with the given values."
    set HELP(jobScript,header) "Executable Script"
    set HELP(jobScript,text) "If you specify an executable script, this script constitutes your job, and will be run\
	    with the shell specified.  <I>An executable script overrides the specification of the <FONT color=yellow>\
	    Executable Name</FONT> (above); the two cannot coexist.</I>"
    set HELP(hold,header) "Job Hold:"
    set HELP(hold,text) "Place a hold on your job when it is submitted.  The job will enter the queue, but will not\
	    execute until the hold is removed."
    set HELP(startdate,header) "Start Date:"
    set HELP(startdate,text) "This is used to specify a starting time and date for your job.  If you specify a valid\
	    value for the start date, your job will enter the queue and be held for execution until the specified time."
    set HELP(parallel_path,header) "Parallel Path"
    set HELP(parallel_path,text) "The parallel path for a PVM job.  This path is of the form <FONT color=yellow><SAMP>\
	    path1:path2</SAMP></FONT>, where <FONT color=yellow><SAMP>path1</SAMP></FONT> is the path to your programs,\
	    and <FONT color=yellow><SAMP>path2</SAMP></FONT> is a path pointing to the location of the\
	    <FONT color=yellow><SAMP>pvmgs</SAMP></FONT> routine.  This option only has an effect for pvm3 jobs."

    # Define help links
    helpSetup HELP

    set workingTitle "$bqs $title"

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	cgi_body bgcolor=$masterBgcolor {
	    # Form
	    cgi_form sessionManager {
		# Basic HTML form elements
		cgi_center {
		    cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
		}

		# Instructions
		cgi_h3 "[cgi_font color=darkmagenta Instructions:]"
		cgi_p "The following module is used to submit general jobs to the LoadLeveler queuing system.\
			Fill out the necessary information related to your job and then simply click\
			[cgi_bold "Submit Job"].  You must specify [cgi_italic either] an [cgi_font color=darkmagenta\
			[cgi_bold "Executable Name"]] or an [cgi_font color=darkmagenta\
			[cgi_bold "Executable Script"]].  Default values will be supplied for other fields\
			in the form if they are left blank.  The form has two modes: [cgi_bold BASIC] mode provides\
			descriptions of each element, whereas this information is omitted in [cgi_bold ADVANCED] mode.\
			Advanced mode also contains additional input fields for more complex jobs.\
			Modes can be switched using the [cgi_link config]."
		cgi_br

		cgi_table cellpadding=3 border=1  {
		    ###########################
		    # Path Information
		    ###########################
		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Job Specification Information"]"][cgi_nbspace][cgi_nbspace][cgi_font color=white\
				"(Current Form Mode: "][cgi_font color=yellow $mode][cgi_font color=white )]"
		    }
		    
		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font color=darkmagenta [cgi_bold "File and Directory Information"]]"
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link initialdir]] on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Directory Name:"]][cgi_nbspace]"
			    cgi_text initialdir=$initialdir size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link executable]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Executable Name:"]][cgi_nbspace]"
			    cgi_text executable=$executable size=35 maxlength=45
			    puts "[cgi_nl][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Arguments:"]][cgi_nbspace]"
			    cgi_text arguments=$arguments size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Data File Names"]"
			cgi_table_data nowrap {
			    cgi_table {
				cgi_table_row {
				    cgi_td "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_bold [cgi_link input]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text input=$input size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_bold [cgi_link output]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text output=$output size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_bold [cgi_link error]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text error=$error size=35 maxlength=45
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font color=darkmagenta [cgi_bold "LoadLeveler Job Information"]]"
		    }	

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link job_type]]"
			cgi_table_data nowrap {
			    cgi_select job_type {
				foreach type [list serial parallel pvm3] {
				    cgi_option $type selected_if_equal=$job_type
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link class]]"
			cgi_table_data nowrap {
			    # Data about classes
			    cgi_table width=100% {
				cgi_table_row {
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Class"]]"
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Max Processors"]]"
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Priority"]]"
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Wall-Clock Limit (hh:mm:ss)"]]"
				    cgi_td align=center "[cgi_font size=-1 color=darkmagenta [cgi_bold "SELECT"]]"
				}

				foreach name $classNameList {
				    cgi_table_row {
					cgi_td align=center "[cgi_font size=-1 $name]"
					cgi_td align=center "[cgi_font size=-1 $CLASS($name,max_processors)]"
					cgi_td align=center "[cgi_font size=-1 $CLASS($name,priority)]"
					regexp {([^,]+).*} $CLASS($name,wall_clock_limit) match limit
					cgi_td align=center "[cgi_font size=-1 $limit]"
					cgi_table_data nowrap align=center {
					    cgi_radio_button class=$name checked_if_equal=$class
					}
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link processors]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Minimum:"]][cgi_nbspace]"
			    cgi_text min_processors=$min_processors size=2
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    puts "[cgi_font color=darkmagenta [cgi_bold "Maximum:"]][cgi_nbspace]"
			    cgi_text max_processors=$max_processors size=2
			}
		    }


		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link job_name]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Job Name:"]][cgi_nbspace]"
			    cgi_text job_name=$job_name size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link jobScript]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Shell:"]][cgi_nbspace]"
			    cgi_select shell {
				foreach sh [list /bin/sh /bin/csh /bin/tcsh /bin/ksh] {
				    cgi_option $sh selected_if_equal=$shell
				}
			    }
			    puts "[cgi_nl]"
			    cgi_textarea jobScript=$jobScript rows=20 cols=70
			}
		    }

		    if {$mode == "ADVANCED"} {
			cgi_table_row {
			    cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white "[cgi_bold "Advanced Options"]"]"
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link requirements]]"
			    cgi_table_data nowrap {
				cgi_checkbox useReqs=1 checked_if_equal=$useReqs
				puts "[cgi_nbspace]Include requirements in submission[cgi_nl]"
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLREQ(Memory)]]]"
				cgi_text LLREQ(Memory)=$LLREQ(Memory) size=4
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLREQ(Feature)]]]"
				cgi_select LLREQ(Feature) {
				    cgi_option Default value= selected_if_equal=$LLREQ(Feature)
				    cgi_option batch-only selected_if_equal=$LLREQ(Feature)
				    cgi_option interactive selected_if_equal=$LLREQ(Feature)
				    cgi_option wide_node selected_if_equal=$LLREQ(Feature)
				    cgi_option tmp2GB selected_if_equal=$LLREQ(Feature)
				    cgi_option 120MHZ selected_if_equal=$LLREQ(Feature)
				}
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLREQ(Adapter)]]]"
				cgi_select LLREQ(Adapter) {
				    cgi_option Default value= selected_if_equal=$LLREQ(Adapter)
				    cgi_option hps_user selected_if_equal=$LLREQ(Adapter)
				    cgi_option ethernet selected_if_equal=$LLREQ(Adapter)
				    cgi_option hps_ip selected_if_equal=$LLREQ(Adapter)
				}
			    }
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link preferences]]"
			    cgi_table_data nowrap {
				cgi_checkbox usePrefs=1 checked_if_equal=$usePrefs
				puts "[cgi_nbspace]Include preferences in submission[cgi_nl]"
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLPREF(Memory)]]]"
				cgi_text LLPREF(Memory)=$LLPREF(Memory) size=4
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLPREF(Feature)]]]"
				cgi_select LLPREF(Feature) {
				    cgi_option Default value= selected_if_equal=$LLPREF(Feature)
				    cgi_option batch-only selected_if_equal=$LLPREF(Feature)
				    cgi_option interactive selected_if_equal=$LLPREF(Feature)
				    cgi_option wide_node selected_if_equal=$LLPREF(Feature)
				    cgi_option tmp2GB selected_if_equal=$LLPREF(Feature)
				    cgi_option 120MHZ selected_if_equal=$LLPREF(Feature)
				}
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLPREF(Adapter)]]]"
				cgi_select LLPREF(Adapter) {
				    cgi_option Default value= selected_if_equal=$LLPREF(Adapter)
				    cgi_option hps_user selected_if_equal=$LLPREF(Adapter)
				    cgi_option ethernet selected_if_equal=$LLPREF(Adapter)
				    cgi_option hps_ip selected_if_equal=$LLPREF(Adapter)
				}
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link environment]]"
			    cgi_table_data nowrap {
				cgi_checkbox env_Copy=1 checked_if_equal=$env_Copy
				puts "[cgi_nbspace]Copy all environment variables[cgi_nl][cgi_nl]"

				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Variables to include\
					(Form: VAR1,VAR2,...,VARN)"]][cgi_nl]"
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				cgi_text env_CopyString=$env_CopyString size=40 maxlength=55

				puts "[cgi_nl][cgi_nl][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Variables\
					to exclude (Form: VAR1,VAR2,...,VARN)"]][cgi_nl]"
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				cgi_text env_ExcludeString=$env_ExcludeString size=40 maxlength=55

				puts "[cgi_nl][cgi_nl][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Variables\
					and their values (Form: VAR1=value1,VAR2=value2,...,VARN=valueN)"]][cgi_nl]"
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				cgi_text env_CopyValueString=$env_CopyValueString size=40 maxlength=55
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link parallel_path]]"
			    cgi_table_data nowrap {
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Program path : pvmgs path"]][cgi_nbspace]"
				cgi_text parallel_path=$parallel_path size=45 maxlength=55
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold "Submission Timing:"]"
			    cgi_table_data nowrap {
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link startdate]]][cgi_nbspace]"
				cgi_text startdate=$startdate size=20 maxlength=20
				puts "[cgi_nbspace]MM/DD/YY HH:mm(:ss)[cgi_nl]"
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link hold]]][cgi_nbspace]"
				cgi_select hold {
				    cgi_option None value=
				    foreach htype [list user system usersys] {
					cgi_option $htype selected_if_equal=$hold
				    }
				}
			    }
			}
			    

		    } else {
			# Set variables for BASIC mode
		    }

		    # Export variables

		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Submit Parallel Job"]"]"
		    }

		    cgi_table_row {
			cgi_table_data nowrap colspan=2 {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_submit_button "action=Submit Job"
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_reset_button
			}
		    }

		    cgi_table_row {
			cgi_table_data nowrap align=center colspan=2 {
			    cgi_export mode=$mode
			    cgi_export moduleName=$moduleName
			    cgi_export hostName=$hostName
			    cgi_export bqs=$bqs
			    cgi_export title=$title
			    cgi_export formProcessor=$cgiHead/$formProcessor.cgi
			    # Session Manager
			    sessionManager $moduleName $hostName
			}
		    }
		}
	    }
	}
    }
}


























































