#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 llMPI.cgi @(#)llMPI.cgi	1.2 SCCS/s.llMPI.cgi  99/05/20 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script llGaussiansubmit.cgi> LL MPI job form generator.

# CODEINFO END ########################################################

# Load WebSubmit package
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    catch {namespace import webSubmit::loadleveler::*}
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::forms::session::*}

    # CGI configuration
    alias webSubmit cgiHead
    cgi_root $cgiHead
    cgi_link config "configuration module" "$cgiHead/config.cgi"

    alias webSubmit::loadleveler PATHS CLASS classNameList

    # Module Variable initialization
    set moduleVarList [list initialdir input output error class\
        min_processors max_processors job_name userExec userArgs\
        job_type useReqs LLREQ(Memory) LLREQ(Adapter) LLREQ(Feature)\
        env_Copy env_CopyString env_ExcludeString env_CopyValueString\
        usePrefs LLPREF(Memory) LLPREF(Adapter) LLPREF(Feature)\
        files2nodes inputFileString outputFileString returnHost returnDir\
        cpOut jobDescription loadedSessName\
        hostName moduleName bqs mode title]
    set reqVarList [list hostName moduleName bqs mode title]
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # Load the current session
    if {[info exists loadedSessName] && "$loadedSessName" != ""} {
	session load -name $loadedSessName $moduleName $hostName
    } else {
	session load $moduleName $hostName
    }	
    getSessionData

    # Read LoadLeveler Keyword Database
    createKeywordDb

    # Get LoadLeveler Class Information
    getClassInfo $hostName
    eval alias webSubmit::loadleveler $webSubmit::loadleveler::dbKeyList

    # CGI configuration
    set formProcessor ${moduleName}submit

    # Get Remote Site information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]

    # Set user notification email address
    set notify_user "$remUser@$hostName"

    # Initialization of variables
    if {$initialdir == ""} {
	set initialdir $remHome
    }

    if {$class == ""} {
	set class [lindex $classNameList 0]
    }

    if {$min_processors == ""} {
	set min_processors 1
    }

    if {$output == ""} {
	set output {$(jobid).out}
    }

    if {$error == ""} {
	set error {$(jobid).err}
    }

    if {$input == ""} {
	set input /dev/null
    }

    if {$returnHost == ""} {
	set returnHost $hostName
    }

    # Set up help information
    set HELP(elementList) [list initialdir input output error class processors\
	    job_name userExec job_type requirements LLREQ(Memory) LLREQ(Adapter) LLREQ(Feature)\
	    environment preferences LLPREF(Memory) LLPREF(Adapter) LLPREF(Feature) files2nodes]
    set HELP(initialdir,header) "Working Directory"
    set HELP(initialdir,text) "Directory to be used as the working directory.  If a relative pathname is provided,\
	    it is interpreted relative to <FONT color=yellow><SAMP>$remHome</SAMP></FONT>.  If no directory\
	    is specified, your home directory is assumed."
    set HELP(input,header) "Standard Input File:"
    set HELP(input,text) "Standard input will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(output,header) "Standard Output File:"
    set HELP(output,text) "Standard output will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(error,header) "Standard Error File:"
    set HELP(error,text) "Standard error will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(job_type,header) "Job Type"
    set HELP(job_type,text) "This determines what type of job will be submitted.  The options are as follows:\
	    <FONT color=yellow><SAMP>serial</SAMP></FONT> - Serial job utilizing one processor;<FONT color=yellow>\
	    <SAMP>parallel</SAMP></FONT> - General parallel job using multiple processors;<FONT color=yellow><SAMP>\
	    pvm3</SAMP></FONT> - Parallel Virtual Machine (pvm) job."
    set HELP(class,header) "Job Class"
    set HELP(class,text) "The job class determines the resource limits (maximum CPU time, number of processors) and\
	    priority for your job.  You should select the class that best meets the requirements for your job."
    set HELP(processors,header) "Number of Processors"
    set HELP(processors,text) "Specify the minimum and maximum number of processors needed for your parallel job.\
	    The default number of min_processors is 1; the default value for max_processors is min_processors."
    set HELP(job_name,header) "Job Name"
    set HELP(job_name,text) "This name is simply used as an identifier for your job.  This may make it easier\
	    to identify the job when examining queue status.  Output and error files can also be named using\
	    the job name by specifying the \$(job_name) command macro."
    set HELP(userExec,header) "Executable Code"
    set HELP(userExec,text) "Executable code to be run in your job; if specified as a relative path, it will be\
	    interpreted as relative to your working directory.  The executable code and its arguments are passed\
	    as arguments to <FONT color=yellow><SAMP>poe</SAMP></FONT> and then executed in the parallel operating\
	    environment."
    set HELP(requirements,header) "Requirements"
    set HELP(requirements,text) "Requirements specify resources that must be present when your job executes.  In order\
	    to include requirements, check the box given."
    set HELP(LLREQ(Memory),header) "Memory (Mb):"
    set HELP(LLREQ(Memory),text) "Amount of memory required for your job (specified in Megabytes)."
    set HELP(LLREQ(Adapter),header) "Adapter:"
    set HELP(LLREQ(Adapter),text) "Type of adapter to use for your parallel job."
    set HELP(LLREQ(Feature),header) "Feature:"
    set HELP(LLREQ(Feature),text) "Additional feature requirements for your jobs"
    set HELP(preferences,header) "Preferences"
    set HELP(preferences,text) "Preferences specify resources that you would like to be present when your job executes.\
	    LoadLeveler will attempt to satisfy these preferences, and if they can't be met, it will attempt to\
	    satisfy requirements.  In order to include preferences, check the box given."
    set HELP(LLPREF(Memory),header) "Memory (Mb):"
    set HELP(LLPREF(Memory),text) "Amount of memory desired for your job (specified in Megabytes)."
    set HELP(LLPREF(Adapter),header) "Adapter:"
    set HELP(LLPREF(Adapter),text) "Type of adapter desired for your parallel job."
    set HELP(LLPREF(Feature),header) "Feature:"
    set HELP(LLPREF(Feature),text) "Additional feature preferences for your jobs"
    set HELP(environment,header) "Job Environment"
    set HELP(environment,text) "Certain properties of the execution environment can be set within LoadLeveler.\
	    By checking the button to copy all environment variables, all variables from your\
	    execution environment will be copied and used by LoadLeveler.  It is also possible to specify\
	    individual variables to include or exclude, and values can be set.  <FONT color=yellow><SAMP>\
	    Including Variables:</SAMP></FONT> Specify the list of variables to include, separated by commas.\
	    <FONT color=yellow><SAMP>Excluding Variables:</SAMP></FONT> Specify the list of variables to exclude,\
	    separated by commas.<FONT color=yellow><SAMP>Specifying by value:</SAMP></FONT> Provide a list of the\
	    form <FONT color=yellow><SAMP>var=value</SAMP></FONT> to be included with the given values."
    set HELP(files2nodes,header) "Transfer Files to Local Nodes"
    set HELP(files2nodes,text) "In order to enhance performance, it is possible to copy your executable and input\
	    files to local nodes for execution.  To copy files in this manner, check the box for transfer and\
	    provide a comma-separated list of input files to copy to the nodes.  Output files can also be returned\
	    from the local nodes to <FONT color=yellow><SAMP>$hostName</SAMP></FONT> once execution is complete by\
	    checking the return box and listing the files to be returned.  Output files will be copied into the\
	    directory specified, the default directory being <FONT color=yellow><SAMP>$remHome</SAMP></FONT>."

    # Define help links
    helpSetup HELP

    set workingTitle "$bqs $title"

    cgi_html {
	cgi_head {
	    cgi_title "workingTitle"
	}
	cgi_body bgcolor=$masterBgcolor {
	    # Form
	    cgi_form sessionManager {
		# Basic HTML form elements
		cgi_center {
		    cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
		}

		# Instructions
		cgi_h3 "[cgi_font color=darkmagenta Instructions:]"
		cgi_p "The following module is used to submit parallel jobs that utilize the Message Passing\
			Interface (MPI) for communication.  Jobs are executed in the Parallel Operating Environment (POE).\
			Fill out the necessary information related to your job and then simply click\
			[cgi_bold "Submit Job"].  The only required information is the [cgi_font color=darkmagenta\
			[cgi_bold "Executable Name"]].  Default values will be supplied for other fields\
			in the form if they are left blank.  The form has two modes: [cgi_bold BASIC] mode provides\
			descriptions of each element, whereas this information is omitted in [cgi_bold ADVANCED] mode.\
			Advanced mode also contains additional input fields for more complex jobs.\
			Modes can be switched using the [cgi_link config]."
		cgi_br

		cgi_table cellpadding=3 border=1  {
		    ###########################
		    # Path Information
		    ###########################
		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Job Specification Information"]"][cgi_nbspace][cgi_nbspace][cgi_font color=white\
				"(Current Form Mode: "][cgi_font color=yellow $mode][cgi_font color=white )]"
		    }
		    
		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font color=darkmagenta [cgi_bold "File and Directory Information"]]"
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link initialdir]] on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Directory Name:"]][cgi_nbspace]"
			    cgi_text initialdir=$initialdir size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link userExec]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Executable Name:"]][cgi_nbspace]"
			    cgi_text userExec=$userExec size=35 maxlength=45
			    puts "[cgi_nl][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Arguments:"]][cgi_nbspace]"
			    cgi_text userArgs=$userArgs size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Data File Names"]"
			cgi_table_data nowrap {
			    cgi_table {
				cgi_table_row {
				    cgi_td "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_font color=darkmagenta [cgi_bold [cgi_link input]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text input=$input size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_font color=darkmagenta [cgi_bold [cgi_link output]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text output=$output size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_font color=darkmagenta [cgi_bold [cgi_link error]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text error=$error size=35 maxlength=45
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font color=darkmagenta [cgi_bold "LoadLeveler Job Information"]]"
		    }	

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link class]]"
			cgi_table_data nowrap {
			    # Data about classes
			    cgi_table width=100% {
				cgi_table_row {
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Class"]]"
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Max Processors"]]"
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Priority"]]"
				    cgi_td align=center "[cgi_font size=-1 [cgi_bold "Wall-Clock Limit (hh:mm:ss)"]]"
				    cgi_td align=center "[cgi_font size=-1 color=darkmagenta [cgi_bold "SELECT"]]"
				}

				foreach name $classNameList {
				    cgi_table_row {
					cgi_td align=center "[cgi_font size=-1 $name]"
					cgi_td align=center "[cgi_font size=-1 $CLASS($name,max_processors)]"
					cgi_td align=center "[cgi_font size=-1 $CLASS($name,priority)]"
					regexp {([^,]+).*} $CLASS($name,wall_clock_limit) match limit
					cgi_td align=center "[cgi_font size=-1 $limit]"
					cgi_table_data nowrap align=center {
					    cgi_radio_button class=$name checked_if_equal=$class
					}
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link processors]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Minimum:"]][cgi_nbspace]"
			    cgi_text min_processors=$min_processors size=2
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    puts "[cgi_font color=darkmagenta [cgi_bold "Maximum:"]][cgi_nbspace]"
			    cgi_text max_processors=$max_processors size=2
			}
		    }


		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link job_name]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Job Name:"]][cgi_nbspace]"
			    cgi_text job_name=$job_name size=35 maxlength=45
			}
		    }

		    if {$mode == "ADVANCED"} {
			cgi_table_row {
			    cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white "[cgi_bold "Advanced Options"]"]"
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link requirements]]"
			    cgi_table_data nowrap {
				cgi_checkbox useReqs=1 checked_if_equal=$useReqs
				puts "[cgi_nbspace]Include requirements in submission[cgi_nl]"
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLREQ(Memory)]]]"
				cgi_text LLREQ(Memory)=$LLREQ(Memory) size=4
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLREQ(Feature)]]]"
				cgi_select LLREQ(Feature) {
				    cgi_option Default value= selected_if_equal=$LLREQ(Feature)
				    cgi_option batch-only selected_if_equal=$LLREQ(Feature)
				    cgi_option interactive selected_if_equal=$LLREQ(Feature)
				    cgi_option wide_node selected_if_equal=$LLREQ(Feature)
				    cgi_option tmp2GB selected_if_equal=$LLREQ(Feature)
				    cgi_option 120MHZ selected_if_equal=$LLREQ(Feature)
				}
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLREQ(Adapter)]]]"
				cgi_select LLREQ(Adapter) {
				    cgi_option Default value= selected_if_equal=$LLREQ(Adapter)
				    cgi_option hps_user selected_if_equal=$LLREQ(Adapter)
				    cgi_option ethernet selected_if_equal=$LLREQ(Adapter)
				    cgi_option hps_ip selected_if_equal=$LLREQ(Adapter)
				}
			    }
			}
			
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link preferences]]"
			    cgi_table_data nowrap {
				cgi_checkbox usePrefs=1 checked_if_equal=$usePrefs
				puts "[cgi_nbspace]Include preferences in submission[cgi_nl]"
				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLPREF(Memory)]]]"
				cgi_text LLPREF(Memory)=$LLPREF(Memory) size=4
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLPREF(Feature)]]]"
				cgi_select LLPREF(Feature) {
				    cgi_option Default value= selected_if_equal=$LLPREF(Feature)
				    cgi_option batch-only selected_if_equal=$LLPREF(Feature)
				    cgi_option interactive selected_if_equal=$LLPREF(Feature)
				    cgi_option wide_node selected_if_equal=$LLPREF(Feature)
				    cgi_option tmp2GB selected_if_equal=$LLPREF(Feature)
				    cgi_option 120MHZ selected_if_equal=$LLPREF(Feature)
				}
				puts "[cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold [cgi_link LLPREF(Adapter)]]]"
				cgi_select LLPREF(Adapter) {
				    cgi_option Default value= selected_if_equal=$LLPREF(Adapter)
				    cgi_option hps_user selected_if_equal=$LLPREF(Adapter)
				    cgi_option ethernet selected_if_equal=$LLPREF(Adapter)
				    cgi_option hps_ip selected_if_equal=$LLPREF(Adapter)
				}
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link environment]]"
			    cgi_table_data nowrap {
				cgi_checkbox env_Copy=1 checked_if_equal=$env_Copy
				puts "[cgi_nbspace]Copy all environment variables[cgi_nl][cgi_nl]"

				puts "[cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Variables to include\
					(Form: VAR1,VAR2,...,VARN)"]][cgi_nl]"
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				cgi_text env_CopyString=$env_CopyString size=40 maxlength=55

				puts "[cgi_nl][cgi_nl][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Variables\
					to exclude (Form: VAR1,VAR2,...,VARN)"]][cgi_nl]"
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				cgi_text env_ExcludeString=$env_ExcludeString size=40 maxlength=55

				puts "[cgi_nl][cgi_nl][cgi_nbspace][cgi_font color=darkmagenta [cgi_bold "Variables\
					and their values (Form: VAR1=value1,VAR2=value2,...,VARN=valueN)"]][cgi_nl]"
				puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace]"
				cgi_text env_CopyValueString=$env_CopyValueString size=40 maxlength=55
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link files2nodes]]"
			    cgi_table_data nowrap {
				cgi_table width=100% {
				    cgi_table_row {
					cgi_table_data nowrap colspan=2 {
					    cgi_checkbox files2nodes=1 checked_if_equal=$files2nodes
					    puts "[cgi_nbspace] Copy input files and executable code\
						    to local nodes for execution[cgi_nl]"
					}
				    }

				    cgi_table_row {
					cgi_td nowrap "[cgi_font color=darkmagenta [cgi_bold "Input Files (Form: file1,...,fileN)"]][cgi_nl]"
					cgi_table_data nowrap {
					    cgi_text inputFileString=$inputFileString size=40 maxlength=45
					}
				    }

				    cgi_table_row {
					cgi_td colspan=2 " "
				    }

				    cgi_table_row {
					cgi_table_data nowrap colspan=2 {
					    cgi_checkbox cpOut=1 checked_if_equal=$cpOut
					    puts "[cgi_nbspace]Copy the specified output files from local nodes to\
						    [cgi_font color=darkmagenta "[cgi_sample $hostName]"] in the specified directory"
					}
				    }

				    cgi_table_row {
					cgi_td nowrap "[cgi_font color=darkmagenta [cgi_bold "Output Files (Form: file1,...,fileN)"]]"
					cgi_table_data nowrap {
					    cgi_text outputFileString=$outputFileString size=40 maxlength=45
					}
				    }
			
				    cgi_table_row {
					cgi_td nowrap "[cgi_font color=darkmagenta [cgi_bold "Output File Directory"]]"
					cgi_table_data nowrap {
					    cgi_text returnDir=$returnDir size=40 maxlength=45
					}
				    }
				}
			    }
			}

		    } else {
			# Set variables for BASIC mode
		    }

		    # Export variables
		    cgi_export job_type=parallel
		    cgi_export executable=[set webSubmit::loadleveler::PATHS($hostName,poe)]
		    cgi_export returnHost=$hostName
		    cgi_export jobDescription=MPI

		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Submit Parallel Job"]"]"
		    }

		    cgi_table_row {
			cgi_table_data nowrap colspan=2 {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_submit_button "action=Submit Job"
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_reset_button
			}
		    }

		    cgi_table_row {
			cgi_table_data nowrap align=center colspan=2 {
			    cgi_export mode=$mode
			    cgi_export moduleName=$moduleName
			    cgi_export hostName=$hostName
			    cgi_export bqs=$bqs
			    cgi_export title=$title
			    cgi_export formProcessor=$cgiHead/$formProcessor.cgi

			    # Session Manager
			    sessionManager $moduleName $hostName 
			}
		    }
		}
	    }
	}
    }
}


















































