#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 llQstat.cgi @(#)llQstat.cgi	1.3 SCCS/s.llQstat.cgi  99/05/20 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script sp2Qstat>  LL queuing system interface.

# CODEINFO END ########################################################


# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    # Aliases
    alias webSubmit cgiHead
    alias webSubmit::loadleveler CLASS classNameList PATHS 
    catch {namespace import webSubmit::forms::*}

    # Module-specific information and general setup
    initVars [list jobInfoList jobList action class llOutput prioArg]
    set moduleVarList [list hostName moduleName mode title bqs]
    set reqVarList [list title bqs hostName moduleName]
    cgiImport $moduleVarList $reqVarList

    # CGI definitions
    cgi_root $cgiHead
    set formProcessor $moduleName

    set headColor darkmagenta
    set tag 0

    # Retrieve class information
    webSubmit::loadleveler::getClassInfo $hostName

    # Definitions for output
    set STATUSTEXT(C) "Complete"
    set STATUSTEXT(D) "Deferred"
    set STATUSTEXT(H) "User Hold"
    set STATUSTEXT(I) "Idle"
    set STATUSTEXT(NQ) "Not Queued"
    set STATUSTEXT(P) "Pending"
    set STATUSTEXT(R) "Running"
    set STATUSTEXT(RM) "Removed"
    set STATUSTEXT(RP) "Remove Pending"
    set STATUSTEXT(S) "System Hold"
    set STATUSTEXT(SH) "System+User Hold"
    set STATUSTEXT(ST) "Starting"
    set STATUSTEXT(V) "Vacated"

    # Get remote site information
    set remUser [webSubmit::auth::authTrans $hostName]

    # Set up command paths
    foreach var [list llcancel llq llprio llhold llclass llstatus jmsum] {
	set ${var}Cmd $PATHS($hostName,$var)
    }

    # Process any pending actions by the user
    if {$action == "Kill Jobs"} {
	# Kill selected jobs on SP2
	if {$jobList != ""} {
	    foreach job $jobList {
		lappend jobInfoList [webSubmit::network::sshCmdExec $remUser $hostName "$llcancelCmd $job"]
	    }
	}
    } elseif {$action == "Generate Listing"} {
	# Query for information about jobs
	if {$jobList != ""} {
	    foreach job $jobList {
		lappend jobInfoList [webSubmit::network::sshCmdExec $remUser $hostName "$llqCmd -l $job"]
	    }
	}
    } elseif {$action == "Change Priority"} {
	# Change execution priority of job(s)
	if {$jobList != "" && $prioArg != ""} {
	    foreach job $jobList {
		lappend jobInfoList [webSubmit::network::sshCmdExec $remUser $hostName "$llprioCmd $prioArg $job"]
	    }
	}
    } elseif {$action == "Hold Jobs"} {
	# Place a hold on selected job(s)
	if {$jobList != ""} {
	    foreach job $jobList {
		lappend jobInfoList [webSubmit::network::sshCmdExec $remUser $hostName "$llholdCmd $job"]
	    }
	}
    } elseif {$action == "Release Jobs"} {
	# Release holds on selected job(s)
	if {$jobList != ""} {
	    foreach job $jobList {
		lappend jobInfoList [webSubmit::network::sshCmdExec $remUser $hostName "$llholdCmd -r $job"]
	    }
	}
    } elseif {$action == "Get Info"} {
	# Get class information
	if ![catch {webSubmit::network::sshCmdExec $remUser $hostName "$llclassCmd -l $class"} result] {
	    set llOutput $result
	}
    } elseif {$action == "Display Status"} {
	# Display machine status
	#  Exits with non-zero status, even without error
	catch {webSubmit::network::sshCmdExec $remUser $hostName "$llstatusCmd -l"} result
	regsub {ERROR \(sshCmdExec\): *} $result "" llOutput
    }

    #######################
    # Get Queue information
    if [catch {webSubmit::network::sshCmdExec $remUser $hostName $llqCmd} result] {
	cgiBomb sp2Qstat.cgi $result
    } else {
	set llq [split $result \n]
    }

    # Get detailed node information
    if [catch {webSubmit::network::sshCmdExec $remUser $hostName $jmsumCmd} result] {
	cgiBomb sp2Qstat.cgi $result
    } else {
	set jmsum [split $result \n]
    }

    set jnl ""
    set llqu ""
    set attrList [list Id Submitted Status Priority Class machine]
    foreach line $llq {
	regsub -all { +} $line " " line
	regsub { $} $line "" line
	set lineflds [split $line]
	if {[llength $lineflds] >= 7 && [lsearch $classNameList [lindex $lineflds 6] ] != -1} {
	    if {[lindex $lineflds 1] == $remUser} {
		lappend llqu $line
		set num [lindex [split [lindex $lineflds 0] "."] 1]
		lappend jnl $num

		# Initialize attributes
		foreach attr $attrList {
		    set QDATA($num,$attr) ""
		}

		# Set attribute values
		set QDATA($num,Id) [lindex $lineflds 0]
		set QDATA($num,Submitted) "[lrange $lineflds 2 3]"
		set status [lindex $lineflds 4]
		catch {set QDATA($num,Status) $STATUSTEXT($status)}
		set QDATA($num,Priority) [lindex $lineflds 5]
		set QDATA($num,Class) [lindex $lineflds 6]
		set QDATA($num,Machine) [lindex $lineflds 7]
	    }
	}
    }
    set jnl [lsort $jnl]
    set llqu [lsort $llqu]

    set workingTitle "$bqs $title"    

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	
	cgi_body bgcolor=$masterBgcolor {
	    # Basic HTML form elements
	    cgi_center {
		cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
	    }
	    cgi_br
	    cgi_form $formProcessor {
                if {"$mode" != ""} {
		    cgi_export mode=$mode
		}
		cgi_export moduleName=$moduleName
		cgi_export hostName=$hostName
		cgi_export title=$title
		cgi_export bqs=$bqs

		# Output generated from commands
		if {$jobInfoList != ""} {
		    cgi_br
		    cgi_h3 "[cgi_font color=darkmagenta "Output for Selected Jobs:"]"
		    cgi_table width=100% border=1 {
			cgi_table_row {
			    cgi_table_data nowrap bgcolor=darkslateblue {
				foreach job $jobList {
				    cgi_h4 "[cgi_font color=yellow "Job Information for job $job"]"
				    set i [lsearch -exact $jobList $job]
				    cgi_preformatted {
					foreach line [split [lindex $jobInfoList $i] \n] {
					    puts "[cgi_font color=white "[cgi_sample $line]"]"
					}
				    }
				}
			    }
			}
		    }
		    cgi_br;cgi_br;cgi_hr
		} elseif {$llOutput != ""} {
		    cgi_br
		    cgi_h3 "[cgi_font color=darkmagenta "Output from $bqs Command:"]"
		    cgi_table width=100% border=1 {
			cgi_table_row {
			    cgi_table_data nowrap bgcolor=darkslateblue {
				cgi_preformatted {
				    foreach line [split $llOutput \n] {
					puts "[cgi_font color=white "[cgi_sample $line]"]"
				    }
				}
			    }
			}
		    }
		    cgi_br;cgi_br;cgi_hr
		}

		###################################################
		#  JOBS QUEUED FOR THE USER
		cgi_h3 "[cgi_font color=darkmagenta "Jobs Currently Queued for:"][cgi_nbspace][cgi_nbspace][cgi_font color=blue "$remUser"]"
		if {$llqu != ""} {
		    cgi_table width=100% border=1 {
			cgi_table_row {
			    foreach attr $attrList {
				cgi_td align=center "[cgi_bold $attr]"
			    }
			    cgi_td align=center "[cgi_bold Select]"
			}
			for {set i 0} {$i < [llength $jnl]} {incr i} {
			    set num [lindex $jnl $i]
			    cgi_table_row {
				foreach attr $attrList {
				    cgi_table_data nowrap align=center {
					if {$QDATA($num,$attr) != ""} {
					    puts [cgi_sample $QDATA($num,$attr)]
					} else {
					    puts [cgi_sample "n/a"]
					}
				    }
				}
				cgi_table_data nowrap align=center {
				    cgi_checkbox "jobList=$num"
				}
			    }
			}
		    }
		} else {
		    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_bold None]"
		}
		cgi_br;cgi_br;cgi_br

		# Detailed node information
		cgi_h3 "[cgi_font color=darkmagenta "Node Listing: "]"
		cgi_preformatted {
		    foreach line $jmsum {
			puts [cgi_sample $line]
		    }
		}

		# Complete Queue Information
		cgi_h3 "[cgi_font color=darkmagenta "Complete Job Listing: "]\
			[cgi_nbspace][cgi_nbspace][cgi_font color=blue "[cgi_sample [::webSubmit::util::tclDate]]"]"
		cgi_preformatted {
		    foreach line $llq {
			puts [cgi_sample $line]
		    }
		}
		cgi_br
		cgi_submit_button "action=Update Queue Information"
		cgi_hr;cgi_br;cgi_br
		

		cgi_h3 "[cgi_font color=darkmagenta "Load Leveler Actions:"]"
		cgi_table width=100% cellpadding=3 border=1 {
		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Description"]"
			cgi_td align=center "[cgi_bold "Execute"]"
		    }

		    cgi_table_row {
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "llclass"]]: Show detailed information for class[cgi_nbspace]"
			    cgi_select class {
				foreach name $classNameList {
				    cgi_option $name
				}
			    }
			}
			cgi_table_data nowrap align=center {
			    cgi_submit_button "action=Get Info"
			}
		    }
		    
		    cgi_table_row {
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "llstatus"]]: Display detailed status for all machines in the Load Leveler cluster"
			}
			cgi_table_data nowrap align=center {
			    cgi_submit_button "action=Display Status"
			}
		    }

		    # Job-related actions
		    if {$llqu != ""} {
			cgi_table_row {
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "llcancel"]]: Kill the Load Leveler jobs selected above"
			    }
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Kill Jobs" "onClick=if (!confirm('Kill jobs?')) return false;"
			    }
			}

			cgi_table_row {
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "llq"]]: Show detailed job information for jobs selected above"
			    }
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Generate Listing"
			    }
			}

			cgi_table_row {
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "llhold"]]: Place a hold on the selected jobs"
			    }
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Hold Jobs"
			    }
			}

			cgi_table_row {
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "llhold -r"]]: Release the hold on the selected jobs"
			    }
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Release Jobs"
			    }
			}

			cgi_table_row {
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "llprio"]]: Change the execution priority of the selected\
					job (relative to your other jobs) by[cgi_nbspace]"
				cgi_text prioArg= size=2
			    }
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Change Priority"
			    }
			}
		    }
		}
	    }
	}
    }
}

















































































































































