#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 lsfJob.cgi @(#)lsfJob.cgi	1.4 SCCS/s.lsfJob.cgi  99/06/19 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script lsfJobLSF.cgi> LSF job form generator.

# CODEINFO END ########################################################

# Load WebSubmit package
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head
    
    catch {namespace import webSubmit::lsf::*}
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::forms::session::*}

    # CGI configuration
    alias webSubmit cgiHead
    alias webSubmit::lsf BSUBOPTS BSUBFLAGS BQUEUES queueList queueHeaderList shell
    cgi_link config "configuration module" "$cgiHead/config.cgi"

    # Module-specific variables and general setup]
    set reqVarList [list hostName moduleName bqs mode title]
    set moduleVarList [list workDir jobScript BSUBOPTS(-o) BSUBOPTS(-i)\
        BSUBOPTS(-e) BSUBOPTS(-J) BSUBOPTS(-c) BSUBOPTS(-M)\
        BSUBOPTS(-b) BSUBOPTS(-q) BSUBOPTS(-u)\
        minProc maxProc jobFileName cpIn cpOut inputFileString\
        outputFileString shell loadedSessName]
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # Load the current session
    if {[info exists loadedSessName] && "$loadedSessName" != ""} {
	session load -name $loadedSessName $moduleName $hostName
    } else {
	session load $moduleName $hostName
    }	
    getSessionData

   # CGI configuration
    cgi_root $cgiHead
    set formProcessor ${moduleName}submit

    # Get Remote Site information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]

    # Get queue information
    getQueueInfo $hostName

    if {$workDir == ""} {
	set workDir $remHome
    }

    if {$BSUBOPTS(-o) == ""} {
	set BSUBOPTS(-o) "%J.out"
    }

    if {$BSUBOPTS(-e) == ""} {
        set BSUBOPTS(-e) "%J.err"
    }

    if {$BSUBOPTS(-q) == ""} {
	set BSUBOPTS(-q) [lindex $queueList 0]
    }

    if {$minProc == ""} {
	set minProc 1
    }
 
    # Set up help information
    set HELP(elementList) [list workDir jobScript BSUBOPTS(-o) BSUBOPTS(-i) BSUBOPTS(-e) BSUBOPTS(-J)\
	    BSUBOPTS(-c) BSUBOPTS(-M) BSUBOPTS(-b) BSUBOPTS(-q) BSUBOPTS(-u) processors jobFileName files2nodes]
    set HELP(workDir,header) "Working Directory"
    set HELP(workDir,text) "Directory to be used as the working directory.  If a relative pathname is provided,\
	    it is interpreted relative to <FONT color=yellow><SAMP>$remHome</SAMP></FONT>.  If no directory\
	    is specified, your home directory is assumed."
    set HELP(jobScript,header) "Executable Script"
    set HELP(jobScript,text) "The script entered in this area contains the commands to be executed as\
	    your job on the system.  In the simplest case, this would just contain the name of the executable\
	    code that you wish to run.  Note that this script executes as if it were run from the working directory."
    set HELP(BSUBOPTS(-o),header) "Standard Output File:"
    set HELP(BSUBOPTS(-o),text) "Standard output will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, output is simply\
	    mailed to the user."
    set HELP(BSUBOPTS(-i),header) "Standard Input File:"
    set HELP(BSUBOPTS(-i),text) "Standard input will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, <FONT color=yellow>\
	    <SAMP>/dev/null</SAMP></FONT> is assumed."
    set HELP(BSUBOPTS(-e),header) "Standard Error File:"
    set HELP(BSUBOPTS(-e),text) "Standard error will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.   If no file is specified, errors are\
	    appended to standard output."
    set HELP(jobFileName,header) "LSF Job Script File Name:"
    set HELP(jobFileName,text) "This is the name that will be used for the file containing your LSF job script.\
	    This script file contains LSF directives specifying job parameters, and the actual executable\
	    script that constitutes your job.  If unspecified, WebSubmit will automatically select a filename.\
	    When your job is submitted, this is done using <FONT color=yellow><SAMP>bsub jobFileName</SAMP></FONT>."
    set HELP(BSUBOPTS(-J),header) "Job Name"
    set HELP(BSUBOPTS(-J),text) "This assigns the specified name to your job request; it is merely an\
	    identifier used by LSF.  If you omit the request name, the default is the name of the job script file\
	    with the leading path name removed."
    set HELP(BSUBOPTS(-c),header) "CPU Time:"
    set HELP(BSUBOPTS(-c),text) "This specifies the maximum CPU time that your entire request will utilize.\
	    In an LSF job context, a request corresponds to all of the commands contained in your job script.\
	    If the time used by your request exceeds this limit, the entire batch request is terminated."
    set HELP(BSUBOPTS(-M),header) "Memory:"
    set HELP(BSUBOPTS(-M),text) "The maximum amount of memory used by your LSF request. In an LSF job context,\
	    a request corresponds to all of the commands contained in your job script.  If the total memory used\
	    by your request exceeds that specified, processes in the request are not allowed to allocate more\
	    memory."
    set HELP(BSUBOPTS(-u),header) "Email Notification"
    set HELP(BSUBOPTS(-u),text) "Specifies the address to which email notification should be sent on job completion.\
	    The address should be of the form <FONT color=yellow><SAMP>user\[@host\]</SAMP></FONT>; if the host is\
	    specified, it must be a valid Internet hostname."
    set HELP(BSUBOPTS(-b),header) "Submission Time"
    set HELP(BSUBOPTS(-b),text) "This controls the time at which your job is submitted for processing.  If you specify\
	    a time in the future, your job will enter the queue and will be help until that time, at which point it\
	    will be allowed to execute.  Allowed formats for specification of time can be found in the <FONT color=yellow>\
	    <SAMP>bsub</SAMP></FONT> manual page."
    set HELP(BSUBOPTS(-q),header) "Job Queue"
    set HELP(BSUBOPTS(-q),text) "The job queue determines the resource limits and\
	    priority for your job.  You should select the queue that best meets the requirements for your job."
    set HELP(files2nodes,header) "Transfer Files to and from Local Nodes"
    set HELP(files2nodes,text) "In order to enhance performance, it is possible to copy your executable and input\
	    files to the local nodes for execution.  To copy files in this manner, check the box for transfer and\
	    provide a comma-separated list of input files to copy to the nodes.  Output files can also be returned\
	    from the local nodes to <FONT color=yellow><SAMP>$hostName</SAMP></FONT> once execution is complete by\
	    checking the return box and listing the files to be returned. Please note that files are copied to\
            <FONT color=yellow><SAMP> /tmp/$remUser </SAMP></FONT> for execution. Output files are returned to\
            <FONT color=yellow><SAMP> /wrk/$remUser </SAMP></FONT>.  It is the responsibility of the user to see that\
            output file names are unique across the remote execution nodes. Note that files are\
            <FONT color=yellow><SAMP> copied</SAMP></FONT>, not <FONT color=yellow><SAMP> deleted</SAMP></FONT>. \
            It is the responsibility of the user to delete their files on the remote nodes. This can easily be done\
            with a built in command in the LSF Queue module. To finalize location of your job on the remote notes\
            please put <FONT color=yellow><SAMP> cd /tmp/$remUser </SAMP></FONT> in the first line of your\
           <FONT color=yellow><SAMP> Executable Script</SAMP></FONT>."
    set HELP(processors,header) "Multiprocessor Specification"
    set HELP(processors,text) "Select the minimum and maximum number of processors to be used in your parallel job.\
	    The default for the minimum is 1; the default for the maximum is the current minimum"

    # Define help links
    helpSetup HELP

    set workingTitle "$bqs $title"

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	cgi_body bgcolor=$masterBgcolor {
	    # Form
	    cgi_form sessionManager {
		# Basic HTML form elements
		cgi_center {
                    cgi_h2 "$workingTitle[cgi_nl]\
                    System [cgi_font color=blue "$hostName"]"
		}

		# Instructions
		cgi_h3 "[cgi_font color=darkmagenta Instructions:]"
		cgi_p "Fill out the necessary information related to your job and then simply click\
			[cgi_bold "Submit Job"].  The only required information is the [cgi_font color=darkmagenta\
			[cgi_bold "Executable Script"]].  Default values will be supplied for other fields\
			in the form if they are left blank.  The form has two modes: [cgi_bold BASIC] mode provides\
			descriptions of each element, whereas this information is omitted in [cgi_bold ADVANCED] mode.\
			Advanced mode also presents the user with more LSF submission options.  Modes can be switched\
			using the [cgi_link config]."
		cgi_br

		cgi_table cellpadding=3 border=1  {
		    ###########################
		    # Path Information
		    ###########################
		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Job Specification Information"]"][cgi_nbspace][cgi_nbspace][cgi_font color=white\
				"(Current Form Mode: "][cgi_font color=yellow $mode][cgi_font color=white )]"
		    }
		    
		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font size=+1 color=darkmagenta [cgi_bold "File and Directory Information"]]"
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link workDir]] on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "Directory Name:"]][cgi_nbspace]"
			    cgi_text workDir=$workDir size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link jobScript]]"
			cgi_table_data nowrap {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
				    [cgi_font color=darkmagenta [cgi_bold "Shell:"]][cgi_nbspace]"
			    cgi_select shell {
				foreach sh [list /bin/sh /bin/csh /bin/tcsh /bin/ksh /bin/bash] {
				    cgi_option $sh selected_if_equal=$shell
				}
			    }
			    puts "[cgi_nl]"
			    cgi_textarea jobScript=$jobScript rows=15 cols=70
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Data File Names"]"
			cgi_table_data nowrap {
			    cgi_table {
				cgi_table_row {
				    cgi_td "[cgi_font color=darkmagenta [cgi_bold [cgi_link BSUBOPTS(-i)]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text BSUBOPTS(-i)=$BSUBOPTS(-i) size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_font color=darkmagenta [cgi_bold [cgi_link BSUBOPTS(-o)]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text BSUBOPTS(-o)=$BSUBOPTS(-o) size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_font color=darkmagenta [cgi_bold [cgi_link BSUBOPTS(-e)]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text BSUBOPTS(-e)=$BSUBOPTS(-e) size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_font color=darkmagenta [cgi_bold [cgi_link jobFileName]]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text jobFileName=$jobFileName size=35 maxlength=45
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font size=+1 color=darkmagenta [cgi_bold "LSF Job Information"]]"
		    }
	
		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link BSUBOPTS(-q)]]"
			cgi_table_data nowrap {
			    # Data about queues
			    cgi_table width=100% {
				cgi_table_row {
				    foreach header $queueHeaderList {
					if {$BQUEUES($header,show)} {
					    cgi_td align=center "[cgi_font size=-1 [cgi_bold "$BQUEUES($header,text)"]]"
					}
				    }
				    cgi_td align=center "[cgi_font size=-1 color=darkmagenta [cgi_bold "SELECT"]]"
				}

				foreach queue $queueList {
				    cgi_table_row {
					foreach header $queueHeaderList {
					    if {$BQUEUES($header,show)} {
						cgi_td align=center "[cgi_font size=-1 $BQUEUES($queue,$header)]"
					    }
					}
					cgi_table_data nowrap align=center {
					    cgi_radio_button BSUBOPTS(-q)=$queue checked_if_equal=$BSUBOPTS(-q)
					}
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link BSUBOPTS(-J)]]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "Name:"]][cgi_nbspace]"
			    cgi_text BSUBOPTS(-J)=$BSUBOPTS(-J) size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Resource Limits"]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold [cgi_link BSUBOPTS(-c)]]][cgi_nbspace]"
			    cgi_text BSUBOPTS(-c)=$BSUBOPTS(-c) size=15 maxlength=20
			    puts "[cgi_nbspace][cgi_nbspace][cgi_bold "Valid format:"] \[hours:\]minutes"
			    puts "[cgi_nl][cgi_font color=darkmagenta [cgi_bold [cgi_link BSUBOPTS(-M)]]][cgi_nbspace]"
			    cgi_text BSUBOPTS(-M)=$BSUBOPTS(-M) size=10 maxlength=20
			    puts "[cgi_nbspace]Mb"
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link processors]]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "Number of processors:"]][cgi_nbspace]Min"
			    cgi_text minProc=$minProc size=2
			    puts "[cgi_nbspace][cgi_nbspace]Max"
			    cgi_text maxProc=$maxProc size=2
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link BSUBOPTS(-u)]]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "Notification Address:"]][cgi_nbspace]"
			    cgi_text BSUBOPTS(-u)=$BSUBOPTS(-u) size=35 maxlength=45
			}
		    }

		    if {$mode == "ADVANCED"} {
			# Form elements for advanced LSF options
			cgi_table_row {
			    cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white [cgi_bold "Advanced LSF Options"]]"
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link files2nodes]]"
			    cgi_table_data nowrap {
				cgi_table width=100% {
				    cgi_table_row {
					cgi_table_data nowrap colspan=2 {
					    cgi_checkbox cpIn=1 checked_if_equal=$cpIn
					    puts "[cgi_nbspace] Copy input files and executable code\
						    to local nodes for execution[cgi_nl]"
					}
				    }

				    cgi_table_row {
					cgi_td nowrap "[cgi_font color=darkmagenta [cgi_bold "Input Files (Form: file1,...,fileN)"]][cgi_nl]"
					cgi_table_data nowrap {
					    cgi_text inputFileString=$inputFileString size=40 maxlength=45
					}
				    }

				    cgi_table_row {
					cgi_td colspan=2 " "
				    }

				    cgi_table_row {
					cgi_table_data nowrap colspan=2 {
					    if {"$cpOut" == ""} {
						set cpOut 0
					    }
					    cgi_checkbox cpOut=1 checked_if_equal=$cpOut
					    puts "[cgi_nbspace]Copy the specified output files from local nodes to\
						    [cgi_font color=darkmagenta "[cgi_sample $hostName]"] on completion"
					}
				    }

				    cgi_table_row {
					cgi_td nowrap "[cgi_font color=darkmagenta [cgi_bold "Output Files (Form: file1,...,fileN)"]]"
					cgi_table_data nowrap {
					    cgi_text outputFileString=$outputFileString size=40 maxlength=45
					}
				    }
				}
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link BSUBOPTS(-b)]]"
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "Time:"]][cgi_nbspace]"
				cgi_text BSUBOPTS(-b)=$BSUBOPTS(-b) size=20 maxlength=45
				puts "[cgi_nbspace][cgi_nbspace][cgi_bold "Valid format:"] \[\[month:\]day:\]hour:minute"
			    }
			}
		    }

		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Submit LSF Job"]"]"
		    }

		    cgi_table_row {
			cgi_table_data nowrap colspan=2 {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_submit_button "action=Submit Job"
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_reset_button
			}
		    }

		    cgi_table_row {
			cgi_table_data nowrap align=center colspan=2 {
			    cgi_export mode=$mode
			    cgi_export moduleName=$moduleName
			    cgi_export hostName=$hostName
			    cgi_export bqs=$bqs
			    cgi_export title=$title
			    cgi_export formProcessor=$cgiHead/$formProcessor.cgi
			    # Session Manager
			    sessionManager $moduleName $hostName 
			}
		    }
		}
	    }
	}
    }
}


























































































































































