#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 master.cgi @(#)master.cgi	1.29 SCCS/s.master.cgi  99/06/25 

#######################################################################
# WebSubmit 2.0:
#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#    Pagoaga
#  Revision: April 1, 1998
#######################################################################

#############################  HEADER  ################################
# info script master.cgi>   Script ot generate master page in right
#    side of main WebSubmit page.  This frame is an outline format
#    text containing links to the different WebSubmit modules.

#######################################################################

# webSubmit setup
set wsLibDir "/sasp/WebSubmit/webSubmit2.5/lib"
lappend auto_path $wsLibDir
package require webSubmit

# Check to see if this is being accessed with a certificate
set verified 0
set certExists [webSubmit::auth::hasCert]
if {$certExists} {
    # Source websubmit.conf for authentication
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf
}

if {$::webSubmit::userName == ""} {
    # User has not been registered
    cgiBomb master "You do not have permission to access this script.  Please register yourself with\
	    the system before attempting to access application modules."
}

cgi_eval {
    # Variable aliases
    alias webSubmit WebSubmit javaScriptHead
    alias webSubmit cgiList userPath
    alias webSubmit::master DB masterList nodeScriptList
    namespace import webSubmit::database::*
    set thisNS webSubmit::master
    
    # Build master DB info
    webSubmit::master::createMasterDb
    
    # Construct list of Ws Scripts
    # set scriptList [list [split $cgiList] [split $nodeScriptList]]
    
    set idColor darkmagenta
    set headColor darkmagenta
    
    #######################
    # Generate HTML via CGI
    #######################

    # HTTP Header
    cgi_http_head
    
    cgi_html {
	cgi_head {
	    cgi_title "WebSubmit Master Page Frame"
	}

	cgi_body bgcolor=$masterBgcolor {

	    cgi_h1 align=center [cgi_font color=$headColor "$WebSubmit Master Page"] 
	    # Generate HTML recursively for each master node
	    foreach master $masterList {
		cgi_h3 [cgi_font color=$headColor [cgi_bold [getDbVal $thisNS $master title]]]
		if [existDbVal $thisNS $master _text] {
		    cgi_p [cgi_font  [getDbVal $thisNS $master _text]]
		}
		webSubmit::master::makeCascade $master
		cgi_br
	    }
	}
    }
}

































































































































































































































































