#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 nqsJob.cgi @(#)nqsJob.cgi	1.4 SCCS/s.nqsJob.cgi  99/05/20 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script nqsJob.cgi> NBS job form generator.

# CODEINFO END ########################################################

# Load WebSubmit package
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head
    
    catch {namespace import webSubmit::nqs::*}
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::forms::session::*}
    catch {namespace import webSubmit::database::*}

    # CGI configuration
    alias webSubmit cgiHead imgHead
    alias webSubmit::nqs QSUBOPTS QSUBFLAGS
    cgi_link config "configuration module" "$cgiHead/config.cgi"

    # Process CGI input 
    set moduleVarList [list hostName moduleName bqs mode title]
    set reqVarList [list hostName moduleName bqs mode title]
    initVars {jobFileName jobScript memUnits notifyUser workDir title}
    set importVarList [cgiImport $moduleVarList $reqVarList]

    # Load the current session
    if {[info exists loadedSessName] && "$loadedSessName" != ""} {
	session load -name $loadedSessName $moduleName $hostName
    } else {
	session load $moduleName $hostName
    }	
    getSessionData

    # CGI configuration
    cgi_root $cgiHead
    set formProcessor ${moduleName}submit

    # Get Remote Site information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]

    if {$workDir == ""} {
	set workDir $remHome
    }

    if {$memUnits == ""} {
	set memUnits "Mb"
    }

    if {$notifyUser == ""} {
	set notifyUser "-me"
    }

    if {$QSUBOPTS(-l,mpp_p) == "" && $mode == "ADVANCED"} {
	set QSUBOPTS(-l,mpp_p) 1
    }

    # Set up help information
    set HELP(elementList) [list workDir jobScript QSUBOPTS(-o) QSUBFLAGS(-ro) QSUBOPTS(-e) QSUBFLAGS(-re)\
	    QSUBFLAGS(-eo) jobFileName QSUBOPTS(-r) QSUBOPTS(-lT) QSUBOPTS(-lM) notifyUser QSUBOPTS(-l,mpp_p)\
	    QSUBOPTS(-a)]
    set HELP(workDir,header) "Working Directory"
    set HELP(workDir,text) "Directory to be used as the working directory.  If a relative pathname is provided,\
	    it is interpreted relative to <FONT color=yellow><SAMP>$remHome</SAMP></FONT>.  If no directory\
	    is specified, your home directory is assumed.  When NQS starts your job, it will actually run as if\
	    executed from your home directory.  <B><I>If you wish to execute in the context of the working directory,\
	    then change into this directory in the executable script.</I></B>"
    set HELP(jobScript,header) "Executable Script"
    set HELP(jobScript,text) "The script entered in this area contains the commands to be executed as\
	    your job on the system.  In the simplest case, this would just contain the name of the executable\
	    code that you wish to run.  Note that this script executes as if it were run from your home\
	    directory.  <B><I>If you wish it to execute in the context of your working directory, then add a command\
	    at the beginning of this script to change into the working directory.</I></B>"
    set HELP(QSUBOPTS(-o),header) "Standard Output File:"
    set HELP(QSUBOPTS(-o),text) "Standard output will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.  If no file is specified, output is directed\
	    to the file <FONT color=yellow><SAMP>request_name.osequence_number</SAMP></FONT>;<FONT color=yellow>\
	    <SAMP>request_name</SAMP></FONT> is the identifier given to the job, and <FONT color=yellow><SAMP>\
	    sequence_number</SAMP></FONT> is a numeric id chosen by NQS."
    set HELP(QSUBFLAGS(-ro),header) "Write output file:"
    set HELP(QSUBFLAGS(-ro),text) "This flag determines how your output is written.  Standard output can either\
	    be buffered (saved) and written at the completion of your job, or it can be written during job\
	    execution."
    set HELP(QSUBOPTS(-e),header) "Standard Error File:"
    set HELP(QSUBOPTS(-e),text) "Standard error will be redirected to this file.  If a relative pathname is provided,\
	    it is interpreted relative to the specified working directory.   If no file is specified, errors are\
	    directed to the file <FONT color=yellow><SAMP>request_name.esequence_number</SAMP></FONT>;\
	    <FONT color=yellow> <SAMP>request_name</SAMP></FONT> is the identifier given to the job, and\
	    <FONT color=yellow><SAMP>sequence_number</SAMP></FONT> is a numeric id chosen by NQS."
    set HELP(QSUBFLAGS(-re),header) "Write error file:"
    set HELP(QSUBFLAGS(-re),text) "This flag determines how your errors are written.  Standard error can either\
	    be buffered (saved) and written at the completion of your job, or it can be written during job\
	    execution."
    set HELP(QSUBFLAGS(-eo),header) "Send errors to output file:"
    set HELP(QSUBFLAGS(-eo),text) "Selecting this flag will cause standard error to be merged with standard output.\
	    In this way, errors and output will be collected in the same output file."
    set HELP(jobFileName,header) "NQS Job Script File Name:"
    set HELP(jobFileName,text) "This is the name that will be used for the file containing your NQS job script.\
	    This script file contains NQS directives specifying job parameters, and the actual executable\
	    script that constitutes your job.  If unspecified, WebSubmit will automatically select a filename.\
	    When your job is submitted, this is done using <FONT color=yellow><SAMP>qsub jobFileName</SAMP></FONT>."
    set HELP(QSUBOPTS(-r),header) "Request Name"
    set HELP(QSUBOPTS(-r),text) "This assigns the specified request name to your job request; it is merely an\
	    identifier used by NQS.  If you omit the request name, the default is the name of the job script file\
	    with the leading path name removed."
    set HELP(QSUBOPTS(-lT),header) "CPU Time:"
    set HELP(QSUBOPTS(-lT),text) "This specifies the maximum CPU time that your entire request will utilize.\
	    In an NQS job context, a request corresponds to all of the commands contained in your job script.\
	    If the time used by your request exceeds this limit, the entire batch request is terminated."
    set HELP(QSUBOPTS(-lM),header) "Memory:"
    set HELP(QSUBOPTS(-lM),text) "The maximum amount of memory used by your NQS request. In an NQS job context,\
	    a request corresponds to all of the commands contained in your job script.  If the total memory used\
	    by your request exceeds that specified, processes in the request are not allowed to allocate more\
	    memory."
    set HELP(notifyUser,header) "Email Notification"
    set HELP(notifyUser,text) "Specifies email notification parameters for your job.  Email regarding your request will\
	    be sent to the NQS host, so you should make sure email can either be received at this address, or that the\
	    appropriate <FONT color=yellow><SAMP>.forward</SAMP></FONT> file is present.  The options are as follows:\
	    <FONT color=yellow><SAMP>Completion</SAMP></FONT> - Send email on job completion; <FONT color=yellow>\
	    <SAMP>Startup</SAMP></FONT> - Send email on job startup; <FONT color=yellow><SAMP>Rerun</SAMP></FONT>\
	    - Send email when job is rerun; <FONT color=yellow><SAMP>Reroute</SAMP></FONT> - Send email if your job\
	    is routed from a pipe queue to a different destination; <FONT color=yellow><SAMP>Do Not Notify</SAMP></FONT>\
	    - Do not send email concerning the job."
    set HELP(QSUBOPTS(-l,mpp_p),header) "Multiprocessor Specification"
    set HELP(QSUBOPTS(-l,mpp_p),text) "Selects the number of processors to use for your parallel job.  If your code\
	    is not written to use parallel processing, this element should be set either to 1 or left blank."
    set HELP(QSUBOPTS(-a),header) "Submission Time"
    set HELP(QSUBOPTS(-a),text) "This controls the time at which your job is submitted for processing.  If you specify\
	    a time in the future, your job will enter the queue and will be help until that time, at which point it\
	    will be allowed to execute.  Allowed formats for specification of time can be found in the <FONT color=yellow>\
	    <SAMP>qsub</SAMP></FONT> manual page."


    # Define Help Links
    helpSetup HELP

    set workingTitle "$bqs $title"

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	cgi_body bgcolor=$masterBgcolor {
	    # Form
	    cgi_form sessionManager {
		# Basic HTML form elements
		cgi_center {
		    cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
		}

		# Instructions
		cgi_h3 "[cgi_font color=darkmagenta Instructions:]"
		cgi_p "Fill out the necessary information related to your job and then simply click\
			[cgi_bold "Submit Job"].  The only required information is the [cgi_font color=darkmagenta\
			[cgi_bold "Executable Script"]].  Default values will be supplied for other fields\
			in the form if they are left blank.  The form has two modes: [cgi_bold BASIC] mode provides\
			descriptions of each element, whereas this information is omitted in [cgi_bold ADVANCED] mode.\
			Advanced mode also presents the user with more NQS submission options.  Modes can be switched\
			using the [cgi_link config]."
		cgi_br

		cgi_table cellpadding=3 border=1  {
		    ###########################
		    # Path Information
		    ###########################
		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Job Specification Information"]"][cgi_nbspace][cgi_nbspace][cgi_font color=white\
				"(Current Form Mode: "][cgi_font color=yellow $mode][cgi_font color=white )]"
		    }
		    
		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font size=+1 color=darkmagenta [cgi_bold "File and Directory Information"]]"
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link workDir]][cgi_nl]\
				on [cgi_font color=darkmagenta "[cgi_sample "$hostName"]"]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "Directory Name:"]][cgi_nbspace]"
			    cgi_text workDir=$workDir size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link jobScript]]"
			cgi_table_data nowrap {
			    cgi_textarea jobScript=$jobScript rows=15 cols=70
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Data File Names"]"
			cgi_table_data nowrap {
			    cgi_table {
				cgi_table_row {
				    cgi_td "[cgi_bold [cgi_link QSUBOPTS(-o)]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text QSUBOPTS(-o)=$QSUBOPTS(-o) size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td align=right "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_link QSUBFLAGS(-ro)][cgi_nbspace]"
				    cgi_table_data nowrap {
					puts "During execution"
					cgi_radio_button QSUBFLAGS(-ro)=on checked_if_equal=$QSUBFLAGS(-ro)
					puts "[cgi_nbspace][cgi_nbspace] Upon Job Completion"
					cgi_radio_button QSUBFLAGS(-ro)=off checked_if_equal=$QSUBFLAGS(-ro)
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_bold [cgi_link QSUBOPTS(-e)]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text QSUBOPTS(-e)=$QSUBOPTS(-e) size=35 maxlength=45
				    }
				}
				cgi_table_row {
				    cgi_td align=right "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]\
					    [cgi_link QSUBFLAGS(-re)][cgi_nbspace]"
				    cgi_table_data nowrap {
					puts "During execution"
					cgi_radio_button QSUBFLAGS(-re)=on checked_if_equal=$QSUBFLAGS(-re)
					puts "[cgi_nbspace][cgi_nbspace] Upon Job Completion"
					cgi_radio_button QSUBFLAGS(-re)=off checked_if_equal=$QSUBFLAGS(-re)
				    }
				}
				cgi_table_row {
				    cgi_table_data nowrap colspan=2 {
					puts "[cgi_bold [cgi_link QSUBFLAGS(-eo)]][cgi_nbspace]"
					cgi_checkbox QSUBFLAGS(-eo)=on checked_if_equal=$QSUBFLAGS(-eo)
				    }
				}
				cgi_table_row {
				    cgi_td "[cgi_bold [cgi_link jobFileName]][cgi_nbspace]"
				    cgi_table_data nowrap {
					cgi_text jobFileName=$jobFileName size=35 maxlength=45
				    }
				}
			    }
			}
		    }

		    cgi_table_row {
			cgi_td colspan=2 "[cgi_font size=+1 color=darkmagenta [cgi_bold "NQS Job Information"]]"
		    }	

		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link QSUBOPTS(-r)]]"
			cgi_table_data nowrap {
			    puts "[cgi_font color=darkmagenta [cgi_bold "Name:"]][cgi_nbspace]"
			    cgi_text QSUBOPTS(-r)=$QSUBOPTS(-r) size=35 maxlength=45
			}
		    }

		    cgi_table_row {
			cgi_td align=center "[cgi_bold "Resource Limits"]"
			cgi_table_data nowrap {
			    puts "[cgi_bold [cgi_link QSUBOPTS(-lT)]][cgi_nbspace]"
			    cgi_text QSUBOPTS(-lT)=$QSUBOPTS(-lT) size=15 maxlength=20
			    puts "[cgi_nbspace][cgi_nbspace][cgi_bold "Valid format:"] \[\[hh:\]mm:\]sec\[.msec\]"
			    puts "[cgi_nl][cgi_bold [cgi_link QSUBOPTS(-lM)]][cgi_nbspace]"
			    cgi_text QSUBOPTS(-lM)=$QSUBOPTS(-lM) size=10 maxlength=20
			    cgi_select memUnits {
				foreach unit [list Kb Kw Mb Mw Gb Gw] {
				    cgi_option $unit selected_if_equal=$memUnits
				}
			    }
			}
		    }



		    cgi_table_row {
			cgi_td align=center "[cgi_bold [cgi_link notifyUser]]"
			cgi_table_data nowrap {
			    # puts "[cgi_font color=darkmagenta [cgi_bold "Notification Address:"]][cgi_nbspace]"
			    # cgi_text QSUBOPTS(-mu)=$QSUBOPTS(-mu) size=35 maxlength=45
			    # puts "[cgi_nl][cgi_nbspace][cgi_nbspace][cgi_font color=darkmagenta "Address must be of the form\
			    #    [cgi_sample user@host],where [cgi_sample host] is a valid Internet hostname"]"
			    puts "[cgi_font color=darkmagenta [cgi_bold "Send Notification on:"]][cgi_nbspace]"
			    cgi_select notifyUser {
				cgi_option Completion value=-me selected_if_equal=$notifyUser
				cgi_option Startup value=-mb selected_if_equal=$notifyUser
				cgi_option Rerun value=-mr selected_if_equal=$notifyUser
				cgi_option Reroute value=-mt selected_=if_equal=$notifyUser
				cgi_option "Do Not Notify" value= selected_if_equal=$notifyUser
			    }
			}
		    }

		    if {$mode == "ADVANCED"} {
			# Form elements for advanced NQS options
			cgi_table_row {
			    cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white [cgi_bold "Advanced NQS Options"]]"
			}
	
			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link QSUBOPTS(-l,mpp_p)]]"
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "Number of processors:"]][cgi_nbspace]"
				cgi_text QSUBOPTS(-l,mpp_p)=$QSUBOPTS(-l,mpp_p) size=2
			    }
			}

			cgi_table_row {
			    cgi_td align=center "[cgi_bold [cgi_link QSUBOPTS(-a)]]"
			    cgi_table_data nowrap {
				puts "[cgi_font color=darkmagenta [cgi_bold "Time:"]][cgi_nbspace]"
				cgi_text QSUBOPTS(-a)=$QSUBOPTS(-a) size=20 maxlength=45
			    }
			}
		    }

		    cgi_table_row {
			cgi_td bgcolor=darkslateblue colspan=2 "[cgi_font size=+1 color=white\
				"[cgi_bold "Submit NQS Job"]"]"
		    }

		    cgi_table_row {
			cgi_table_data nowrap colspan=2 {
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_submit_button "action=Submit Job"
			    puts "[cgi_nbspace][cgi_nbspace][cgi_nbspace][cgi_nbspace]"
			    cgi_reset_button
			}
		    }

		    cgi_table_row {
			cgi_table_data nowrap align=center colspan=2 {
			    cgi_export mode=$mode
			    cgi_export moduleName=$moduleName
			    cgi_export hostName=$hostName
			    cgi_export bqs=$bqs
			    cgi_export title=$title
			    cgi_export formProcessor=$cgiHead/$formProcessor.cgi
			    # Session Manager
			    sessionManager $moduleName $hostName 
			}
		    }
		}
	    }
	}
    }
}





















