#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 nqsJobsubmit.cgi @(#)nqsJobsubmit.cgi	1.5 SCCS/s.nqsJobsubmit.cgi  99/05/20 


# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script nqsJobsubmit.cgi> NQS job submission processor.

# CODEINFO END ########################################################

# Load websubmit information
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    catch {namespace import webSubmit::nqs::*}

    # Variable aliasing
    alias webSubmit::nqs QSUBOPTS QSUBFLAGS jobFileName jobScript workDir

    # Initialize module variables
    set moduleVarList [list hostName title workDir jobScript QSUBOPTS(-o)\
        QSUBOPTS(-e) QSUBFLAGS(-ro) QSUBFLAGS(-re) QSUBFLAGS(-eo) QSUBOPTS(-r)\
       	QSUBOPTS(-lT) QSUBOPTS(-lM) memUnits notifyUser QSUBOPTS(-l,mpp_p)\
	QSUBOPTS(-a) jobFileName loadedSessName]
    set reqVarList [list hostName title bqs jobScript QSUBFLAGS(-ro)\
        QSUBFLAGS(-re) notifyUser memUnits]
    cgiImport $moduleVarList $reqVarList

    # Get remote information
    set remUser [webSubmit::auth::authTrans $hostName]
    set remHome [webSubmit::network::getRemEnv HOME $remUser $hostName]
    set workDir [mkPathAbs $workDir $remHome]

    # Verify CGI input information
    set INPUT(varList) [list workDir QSUBOPTS(-lM) QSUBOPTS(-o) QSUBOPTS(-e) QSUBOPTS(-l,mpp_p) jobFileName]
    set INPUT(workDir) [list noWhite isDirectory]
    set INPUT(workDir,isDirectory,hostName) $hostName
    set INPUT(workDir,isDirectory,remUser) $remUser
    set INPUT(QSUBOPTS(-lM)) isPositiveInt
    set INPUT(QSUBOPTS(-o)) noWhite
    set INPUT(QSUBOPTS(-e)) noWhite
    set INPUT(QSUBOPTS(-l,mpp_p)) isPositiveInt
    set INPUT(jobFileName) noWhite
    inputVerify INPUT 

    ###############################################
    # Process form data
    ###############################################

    # Set up output and error filenames
    if {$QSUBOPTS(-o) != ""} {
	set QSUBOPTS(-o) [mkPathAbs $QSUBOPTS(-o) $workDir]
	if {$QSUBFLAGS(-eo) == "on"} {
	    set QSUBOPTS(-e) ""
	    set QSUBFLAGS(-re) "off"
	}
    }

    if {$QSUBOPTS(-e) != ""} {
	set QSUBOPTS(-e) [mkPathAbs $QSUBOPTS(-e) $workDir]
    }

    # Set up email notification
    if {$notifyUser != ""} {
	set QSUBFLAGS($notifyUser) "on"
    }

    # Check resources requested against queue limits
    checkLimits $hostName maxMemory $QSUBOPTS(-lM) $memUnits
    checkLimits $hostName maxCPUTime $QSUBOPTS(-lT)
    checkLimits $hostName maxProcessors $QSUBOPTS(-l,mpp_p)

    # Append memory units if memory limits specified
    if {$QSUBOPTS(-lM) != ""} {
	append QSUBOPTS(-lM) $memUnits
    }

    set workingTitle "$bqs $title Report"

    cgi_html {
	cgi_head {cgi_title "$workingTitle"}
	cgi_body bgcolor=$masterBgcolor {
	    cgi_center {
		cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
	    }

	    # Submit NQS Job
	    submitNQSjob $hostName $remHome $remUser
	}
    }
}






























































































































