#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 nqsQstat.cgi @(#)nqsQstat.cgi	1.5 SCCS/s.nqsQstat.cgi  99/05/20 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script nqsQstat.cgiT>  NQS queuing system interface.

# CODEINFO END ########################################################


# webSubmit setup
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off

cgi_eval {
    # HTTP Header
    cgi_http_head

    # Aliases
    alias webSubmit cgiHead
    alias webSubmit::nqs QSTAT QSTATINFO PATHS

    catch {namespace import webSubmit::nqs::*}
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::database::*}

    # Process CGI input
    initVars [list jobInfoList jobList action title]
    set moduleVarList [list hostName moduleName mode title bqs]
    set reqVarList [list title bqs hostName moduleName]
    cgiImport $moduleVarList $reqVarList

    # CGI definitions
    cgi_root $cgiHead
    set formProcessor $moduleName

    set headColor darkmagenta
    set tag 0

    # Get remote site information
    set remUser [webSubmit::auth::authTrans $hostName]

    # Process any pending actions by the user
    set qdelCmd $PATHS($hostName,qdel)
    set qstatCmd $PATHS($hostName,qstat)
    if {$action == "Kill Jobs"} {
	# Kill selected NQS jobs
	if {$jobList != ""} {
	    lappend jobInfoList [webSubmit::network::sshCmdExec $remUser\
                $hostName "$qdelCmd -k $jobList"]
	}
    } elseif {$action == "Generate Listing"} {
	# Query for information about jobs
	if {$jobList != ""} {
	    foreach job $jobList {
		lappend jobInfoList [webSubmit::network::sshCmdExec $remUser\
                    $hostName "$qstatCmd -f $job"]
	    }
	}
    }

    #######################
    # Get Queue information
    #######################
    if [catch {webSubmit::network::sshCmdExec $remUser $hostName $qstatCmd} result] {
	cgiBomb "nqsQstat.cgi for $hostName" $result
    } else {
	set qstatInfo [split $result \n]
    }

    # Get information about user jobs
    if [catch {webSubmit::network::sshCmdExec $remUser $hostName "$qstatCmd -a"} result] {
	cgiBomb "nqsQstat.cgi for $hostName" $result
    } else {
	set jobInfo [split $result \n]
    }

    # Parse user job information
    parseQstatInfo $jobInfo -a
    set jobList $QSTATINFO(jobIdList)

    set workingTitle "$bqs $title"    

    cgi_html {
	cgi_head {
	    cgi_title "$workingTitle"
	}
	
	cgi_body bgcolor=$masterBgcolor {
	    # Basic HTML form elements
	    cgi_center {
		cgi_h2 "$workingTitle[cgi_nl]\
		    System [cgi_font color=blue "$hostName"]"
	    }
	    cgi_br
	    cgi_form $formProcessor {
                if {"$mode" != ""} {
		    cgi_export mode=$mode
		}
		cgi_export moduleName=$moduleName
		cgi_export hostName=$hostName
		cgi_export title=$title
		cgi_export bqs=$bqs

		# Output generated from commands
		if {$jobInfoList != ""} {
		    cgi_br
		    cgi_h3 "[cgi_font color=darkmagenta "Output:"]"
		    cgi_table width=100% border=1 {
			cgi_table_row {
			    cgi_table_data nowrap bgcolor=darkslateblue {
				if {$jobList != ""} {
				    foreach job $jobList {
					cgi_h4 "[cgi_font color=yellow "Job Information for job $job"]"
					set i [lsearch -exact $jobList $job]
					cgi_preformatted {
					    foreach line [split [lindex $jobInfoList $i] \n] {
						puts "[cgi_font color=white "[cgi_sample $line]"]"
					    }
					}
				    }
				} else {
				    cgi_preformatted {
					foreach line [split $jobInfoList \n] {
					    puts "[cgi_font color=white "[cgi_sample $line]"]"
					}
				    }
				}
			    }
			}
		    }
		    cgi_br;cgi_br;cgi_hr
		}

		###################################################
		# Information about user jobs
		cgi_h3 "[cgi_font color=darkmagenta "Jobs Currently Queued for:"]\
                    [cgi_nbspace][cgi_nbspace][cgi_font color=blue "$remUser"]"
		if {$jobList != ""} {
		    cgi_table cellpadding=3 border=1 {
			cgi_table_row {
			    cgi_td align=center "[cgi_bold "Job Number"]"
			    foreach elt $QSTAT(-a,header) {
				if {$QSTAT($elt,show)} {
				    cgi_td align=center "[cgi_bold $QSTAT($elt,text)]"
				}
			    }
			    cgi_td align=center "[cgi_bold Select]"
			}

			foreach job $jobList {
			    cgi_table_row {
				cgi_td align=center "[cgi_font color=blue [cgi_bold $job]]"
				foreach elt $QSTAT(-a,header) {
				    set value $QSTATINFO($job,$elt)
				    if {$QSTAT($elt,show)} {
					if {$elt == "ST"} {
					    # Process major and minor status (if available)
					    if [info exists QSTAT(ST,major,$value)] {
						cgi_td align=center "$QSTAT(ST,major,$value)"
					    } elseif {[string length $value] == 3} {
						set major [string range $value 0 0]
						set minor [string range $value 1 2]
						if [info exists QSTAT(ST,major,$major)] {
						    set majorString $QSTAT(ST,major,$major)
						} else {
						    set majorString "Unknown"
						}
						
						if [info exists QSTAT(ST,minor,$minor)] {
						    set minorString $QSTAT(ST,minor,$minor)
						} else {
						    set minorString "Unknown"
						}
						cgi_td align=center "$majorString ($minorString)"
					    } else {
						cgi_td align=center "$value"
					    }
					} elseif {$elt == "LOCATION/QUEUE"} {
					    regexp {([^@]+).*} $value match q
					    cgi_td align=center $q
					} else {
					    cgi_td align=center "$value"
					}
				    }
				}
				cgi_table_data nowrap align=center {
				    cgi_checkbox "jobList=$job"
				}
			    }
			}
		    }
		} else {
		    puts "[cgi_nbspace][cgi_nbspace][cgi_bold None]"
		}
		cgi_br;cgi_br;cgi_br

		# Complete Queue Information
		cgi_h3 "[cgi_font color=darkmagenta "Queue Summary: "]\
			[cgi_nbspace][cgi_nbspace][cgi_font color=blue\
			 "[cgi_sample [webSubmit::util::tclDate]]"]"
		cgi_preformatted {
		    foreach line $qstatInfo {
			puts [cgi_sample $line]
		    }
		}
		cgi_br
		cgi_submit_button "action=Update Queue Information"
		cgi_hr;cgi_br;cgi_br

		if {$jobList != ""} {
		    cgi_h3 "[cgi_font color=darkmagenta "$bqs Actions:"]"
		    cgi_table width=90% cellpadding=3 border=1 {
			cgi_table_row {
			    cgi_td align=center "[cgi_bold "Description"]"
			    cgi_td align=center "[cgi_bold "Execute"]"
			}
			
			cgi_table_row {
			    cgi_td "[cgi_font color=darkmagenta [cgi_bold "qstat -f"]]: Get detailed information about the selected jobs"
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Generate Listing"
			    }
			}

			cgi_table_row {
			    cgi_td "[cgi_font color=darkmagenta [cgi_bold "qdel -k"]]: Kill all of the selected jobs"
			    cgi_table_data nowrap align=center {
				cgi_submit_button "action=Kill Jobs" "onClick=if (!confirm('Kill jobs?')) return false;"
			    }
			}
		    }
		}
	    }
	}
    }
}












































