#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 sessionManager.cgi @(#)sessionManager.cgi	1.7 SCCS/s.sessionManager.cgi  99/05/20 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script sessionManager.cgi> Hand off module session.

# CODEINFO END ########################################################

# Load webSubmit package
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf

cgi_debug -off
cgi_eval {
    # Namespace imports and aliases
    catch {namespace import webSubmit::forms::*}
    catch {namespace import webSubmit::forms::session::*}

    # Variable initialization
    alias webSubmit cgiHead
    alias webSubmit::forms::session userDefName userLastName systemDefName\
        loadedSessName
    cgi_root $cgiHead
    set optVarList [list mode title moduleName hostName bqs\
        sessionAction sessName newSessName formProcessor]
    set reqVarList [list mode title moduleName hostName bqs]
    set varList [cgiImport $optVarList $reqVarList]

    # Filter out all manager-specific variables to obtain list of form 
    # variables for session
    set managerVarList [concat $optVarList $reqVarList]
    set sessVarList ""
    foreach var $varList {
	if {[lsearch -exact $managerVarList $var] == -1} {
	    lappend sessVarList $var
	}
    }

    foreach var $sessVarList {
	set $var [string trim "[set $var]"]
    }

    # Make sure that user has a directory for this module
    checkUserModule $moduleName $hostName

    # Fix up new session names that disallowed characters for UNIX filenames

    if {$newSessName != ""} {
	regsub -all "\[ \t*?\]" $newSessName "_" newSessName
    }

    # Determine what session actions need to be taken
    #  sessionAction = ""  --> Save session data as 'Last'
    #  sessionAction != "" --> Perform appropriate action
    if {$sessionAction == ""} {
	# Save as 'Last' session
	session save -name $userLastName -vars "$sessVarList" $moduleName\
            $hostName
    } elseif {$sessionAction == "Load Library Session"} {
	# Load using specified session
	set loadedSessName "$sessName"
#	session load -name $sessName $moduleName $hostName
    } elseif {$sessionAction == "Load System Defaults"} {
	# Load the system-wide default session
#	session load --default $moduleName $hostName
    } elseif {$sessionAction == "Save"} {
	# Save as named library session
	set loadedSessName "$newSessName"
	session save -name $newSessName -vars "$sessVarList" $moduleName\
            $hostName
    } elseif {$sessionAction == "Delete Selected Session"} {
	# Delete the library session currently selected in pull-down
	session delete -name "$sessName" $moduleName $hostName
#	session load $moduleName $hostName
    } elseif {$sessionAction == "Save As Default"} {
	# Save as default session
	set loadedSessName "$userDefName"
	session save -name $userDefName -vars "$sessVarList" $moduleName\
            $hostName
    }

    # Specify what session to load in the module to which control is returned
    set sessData [getCgiData]
    if {$loadedSessName != ""} {
	append sessData "&loadedSessName=$loadedSessName"
    }

    if ![info exists env(HTTP_REFERER)] {
	set env(HTTP_REFERER) "${webSubmit::cgiHead}/websubmit.cgi"
    } else {
	# Clean up HTTP_REFERER in case this came with some sort of query string
	regexp {([^\?]+)\?.*} $env(HTTP_REFERER) match env(HTTP_REFERER)
    }

    # CGI redirect to submitting module
    cgi_http_head {
	set moduleArgs [queryString mode $mode moduleName $moduleName\
			    hostName $hostName bqs $bqs title $title]	     
	if {$sessionAction == ""} {
	    # Redirect to form processor
	    cgi_target output
	    cgi_redirect "$formProcessor?$moduleArgs$sessData"
	} else {
	    # Redirect back to invoking form
	    cgi_redirect "$env(HTTP_REFERER)?$moduleArgs$sessData"
	}
    }
}























































































