#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 setup.cgi @(#)setup.cgi	1.8 SCCS/s.setup.cgi  98/06/01 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script setup.cgi> Script to display setup instructions

# CODEINFO END ########################################################

# Initialize WebSubmit environment
set wsLibDir "/sasp/WebSubmit/webSubmit2.5/lib"
lappend auto_path $wsLibDir
package require webSubmit

# Variable aliases
alias webSubmit cgiHead serverUser serverHost adminMailAddr

# Build Web Page
cgi_eval {
    # HTTP Header
   cgi_http_head
   
    # Body
    cgi_html {

      cgi_body bgcolor=$masterBgcolor {
	  cgi_center {
	      cgi_h2 "[cgi_font color=blue "Welcome to WebSubmit!"]"
	  }
	  cgi_p "This page contains instructions for how to perform the necessary\
		  setup to use the WebSubmit application interfaces.  If you have\
		  any questions about the necessary setup procedures, please\
		  send email to the [cgi_url "WebSubmit Administrator" "mailto:$adminMailAddr"]"
	  cgi_br

	  cgi_h3 "[cgi_font color=darkmagenta "Setup Instructions"]"
	  cgi_p "In order to use WebSubmit application modules, a minimal amount of\
		  setup is required on the remote hosts you wish to access.  For each\
		  remote host on which you have an account, you must create a file called\
		  [cgi_bold [cgi_sample .shosts]] in your HOME directory.  This file must\
		  contain the following line:"

	  cgi_preformatted {
	      puts "[cgi_sample "[cgi_nbspace][cgi_nbspace]$serverHost $serverUser"]"
	  }

	  cgi_p "The file should have permissions 600 (read-write by user only).  [cgi_bold\
		  "If this file is not present on every WebSubmit host you\
		  wish to access, you will be unable to use any application modules."]\
		  The FAQ contains information about the hosts available on the system."
	  cgi_br

	  cgi_h3 "[cgi_font color=darkmagenta "Gaining Access to the System"]"
	  cgi_p "You may access and use WebSubmit application modules if all of\
		  the following are true:"
	  cgi_number_list {
	      cgi_li "You have been issued a personal digital certificate"
	      cgi_li "The certificate has been loaded into your browser"
	      cgi_li "The WebSubmit administrator has notified you via email\
		      that you have been registered with the system"
	      cgi_li "You have created [cgi_sample .shosts] files on all remote hosts you\
		      wish to access."
	  }

	  cgi_p "If these conditions are met, you should proceed to the  \
		  [cgi_url "Secure Server" "$cgiHead/websubmit.cgi" target=master].  If\
		  everything is as it should be, you will see a list of available\
		  application modules along with brief descriptions."
      }
  }
}











