#!/itl/links/generic/bin/tclsh8.0
# WebSubmit 2.0 websubmit.cgi @(#)websubmit.cgi	1.18 SCCS/s.websubmit.cgi  99/06/25 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info script> Script to generate simple frame scheme for WebSubmit 
#     master page

# CODEINFO END ########################################################

# Initialize WebSubmit environment
set wsLibDir "/sasp/WebSubmit/webSubmit2.5/lib"
lappend auto_path $wsLibDir
package require webSubmit

# Variable aliases
alias webSubmit::auth certEnvName
alias webSubmit nHttpHead nDocHead

# Check to see if this is being accessed with a certificate
set verified 0
set certExists [webSubmit::auth::hasCert]

# Authenticate
if {$certExists} {
source /sasp/WebSubmit/webSubmit2.5/bin/websubmit.conf
}

if {$::webSubmit::userName != ""} {
    set verified 1
}

cgi_eval {
    # HTTP Header
    cgi_http_head

    # Framesets
    cgi_html {
	cgi_title "WebSubmit Master Page"

	if {$certExists && !($verified)} {
	    set msg " Your certificate has not yet been stored in the WebSubmit system.\\n\
	        Your identity will be verified and you will be contacted when you\\n\
	        can access the system.  You cannot access application modules until\\n\
		that time."
	    alert "$msg"
	}

	cgi_frameset frameborder=yes border=1 rows=*,125 {
	    # LHS links column
	    cgi_frameset cols=200,* {
		cgi_frame linkbar=linkbar.cgi
		if {$certExists && $verified} {
		    # Main body of page
		    cgi_frame master=master.cgi
		} else {
		    cgi_frame master=setup.cgi
		}
	    }

	    cgi_frameset cols=200,* {
		cgi_frame linkfoot=linkfooter.cgi scrolling=no
		cgi_frame help=helper.cgi
	    }
	}
    }
}

















































































































































































































































































































































































































