#ifndef _CERTUTIL_H_
#define _CERTUTIL_H_
/*
 * @(#)10  1.1  src/lib/vvcertutil/vvcertutil.h, vaultTS, vaultTS_dev 06/07/97 17:43:07
 *
 * certutil.h
 *	this file contains definitions for the certificate processing
 *	functions in certutil.c
 * 
 * Author(s)
 *	Scott A. Leerssen
 * 
 * Disclaimer
 *	This source code is being provided AS IS with no warranty.
 *	Neither the hacker (Scott Leerssen) nor HP is responsible for
 *	the suitability for use, or the use of this code in any manner.
 *	This code may be used as is, or modified for use for however
 *	you see fit as long as the comment block containing this notice
 *	remains in tact.  I (Scott Leerssen, again) as well as HP just
 *	love to have our names recognized when someone uses our stuff,
 *	so just do the right thing.
 *
 * Protection Notice
 *	Copyright (c) 1997, Hewlett-Packard.  All rights reserved.
 */
#include "list.h"

typedef list_t cert_t;

cert_t *cert_decode(u_char *asn_p);
cert_t *cert_b64_decode(char *b64_p);
void cert_free(cert_t *cert_p);
int cert_version(cert_t *cert_p);
int cert_serial_number(cert_t *cert_p, u_char **ser_pp);
char *cert_signature_alg_id(cert_t *cert_p);
char *cert_issuer_dn(cert_t *cert_p);
char *cert_validity_start(cert_t *cert_p);
char *cert_validity_end(cert_t *cert_p);
char *cert_subject_dn(cert_t *cert_p);
char *cert_public_key_alg_id(cert_t *cert_p);
int cert_public_key(cert_t *cert_p, u_char **pub_key_pp);
char *cert_issuer_signature_alg_id(cert_t *cert_p);
int cert_issuer_signature(cert_t *cert_p, u_char **issuer_sig_pp);
char *cert_UTC2ctime(char *UTCtime);
int b64decode(char *b64_p, char **data_p);

#endif
