# WebSubmit 2.0 safeInterp.tcl @(#)safeInterp.tcl	1.1 SCCS/s.safeInterp.tcl  98/09/30 

# AUTHORS #############################################################

#  Authors: John Koontz, Ryan McCormack, Judith Devaney
#  Original Development Work: Robert Lipman, John Koontz, Katherine
#      Pagoaga

# Copyright Information ###############################################

# This software was developed at the National Institute of Standards
# and Technology by employees of the Federal Government in the course
# of their official duties.  Pursuant to title 17 Section 105 of the
# United States Code this software is not subject to copyright
# protection and is in the public domain.

# CODEINFO BEGIN ######################################################

# info package safeInterp > This is a collection of procedures to be
#   used in the context of a safe interpreter within webSubmit

# CODEINFO END ########################################################

####################################
# General Variable Initialization
####################################

####################################
# Procedures
####################################

# CODEINFO BEGIN ##################################################
# info proc getNSTree> Procedure to retrieve the tree containing
#     all namespace names that are children (or their descendants)
#     within a given root namespace.  Root namespace is assumed
#     to exist.  This version of the procedure is similar to
#     that found in ::webSubmit::util, although it is stripped
#     down for speed.

proc getNSTree {{rootNS ::}} {
    global nsList
    
    # Retrieve children at the level of the tree and descend if necessary
    set children [namespace children $rootNS]
    if {$children == ""} {
	return
    } else {
	foreach child $children {
	    lappend nsList $child
	    getNSTree $child
	}
    }
    return $nsList
}


